C I AND J ARE IBM FORTRAN DOUBLE AND SINGLE LENGTH VERSIONS  JSDI/      MC20A.3
C D AND S ARE STANDARD FORTRAN DOUBLE AND SINGLE LENGTH VERSIONS
C     SUBROUTINE MC20AD(NC,MAXA,A,INUM,JPTR,JNUM,JDISP)              ID/MC20A.5
C                                                                       MC20A.6
      SUBROUTINE MC20A (NC,MAXA,A,INUM,JPTR,JNUM,JDISP)
      INTEGER INUM(MAXA),JNUM(MAXA)
C     DOUBLE PRECISION A(MAXA),ACE,ACEP                              ID/MC20A.10
      REAL A(MAXA)
      DIMENSION JPTR(NC)
C                                                                       MC20A.13
C     ******************************************************************MC20A.14
C                                                                       MC20A.15
      NULL=-JDISP
C**      CLEAR JPTR                                                     MC20A.17
      DO 60 J=1,NC
   60 JPTR(J)=0
C**      COUNT THE NUMBER OF ELEMENTS IN EACH COLUMN.                   MC20A.20
      DO 120 K=1,MAXA
      J=JNUM(K)+JDISP
      JPTR(J)=JPTR(J)+1
  120 CONTINUE
C**      SET THE JPTR ARRAY                                             MC20A.25
      K=1
      DO 150 J=1,NC
      KR=K+JPTR(J)
      JPTR(J)=K
  150 K=KR
C                                                                       MC20A.31
C**      REORDER THE ELEMENTS INTO COLUMN ORDER.  THE ALGORITHM IS AN   MC20A.32
C        IN-PLACE SORT AND IS OF ORDER MAXA.                            MC20A.33
      DO 230 I=1,MAXA
C        ESTABLISH THE CURRENT ENTRY.                                   MC20A.35
      JCE=JNUM(I)+JDISP
      IF(JCE.EQ.0) GO TO 230
      ACE=A(I)
      ICE=INUM(I)
C        CLEAR THE LOCATION VACATED.                                    MC20A.40
      JNUM(I)=NULL
C        CHAIN FROM CURRENT ENTRY TO STORE ITEMS.                       MC20A.42
      DO 200 J=1,MAXA
C        CURRENT ENTRY NOT IN CORRECT POSITION.  DETERMINE CORRECT      MC20A.44
C        POSITION TO STORE ENTRY.                                       MC20A.45
      LOC=JPTR(JCE)
      JPTR(JCE)=JPTR(JCE)+1
C        SAVE CONTENTS OF THAT LOCATION.                                MC20A.48
      ACEP=A(LOC)
      ICEP=INUM(LOC)
      JCEP=JNUM(LOC)
C        STORE CURRENT ENTRY.                                           MC20A.52
      A(LOC)=ACE
      INUM(LOC)=ICE
      JNUM(LOC)=NULL
C        CHECK IF NEXT CURRENT ENTRY NEEDS TO BE PROCESSED.             MC20A.56
      IF(JCEP.EQ.NULL) GO TO 230
C        IT DOES.  COPY INTO CURRENT ENTRY.                             MC20A.58
      ACE=ACEP
      ICE=ICEP
  200 JCE=JCEP+JDISP
C                                                                       MC20A.62
  230 CONTINUE
C                                                                       MC20A.64
C**      RESET JPTR VECTOR.                                             MC20A.65
      JA=1
      DO 250 J=1,NC
      JB=JPTR(J)
      JPTR(J)=JA
  250 JA=JB
      RETURN
      END
      SUBROUTINE MC20B(NC,MAXA,A,INUM,JPTR)                             MC20A.74
C     SUBROUTINE MC20BD(NC,MAXA,A,INUM,JPTR)                         ID/MC20A.73
C     DOUBLE PRECISION A(MAXA),ACE                                   ID/
      REAL A(MAXA)
      INTEGER INUM(MAXA)
      DIMENSION JPTR(NC)
C                                                                       MC20A.80
C     ******************************************************************MC20A.81
C                                                                       MC20A.82
      KMAX=MAXA
      DO 30 JJ=1,NC
      J=NC+1-JJ
      KLO=JPTR(J)+1
      IF(KLO.GT.KMAX)GO TO 30
      KOR=KMAX
      DO 25 KDUMMY=KLO,KMAX
C ITEMS KOR, KOR+1, .... ,KMAX ARE IN ORDER                             MC20A.90
      ACE=A(KOR-1)
      ICE=INUM(KOR-1)
      DO 10 K=KOR,KMAX
      IK=INUM(K)
      IF(IABS(ICE).LE.IABS(IK))GO TO 20
      INUM(K-1)=IK
10    A(K-1)=A(K)
      K=KMAX+1
20    INUM(K-1)=ICE
      A(K-1)=ACE
25    KOR=KOR-1
C        NEXT COLUMN                                                    MC20A.10
30    KMAX=KLO-2
      RETURN
      END
      SUBROUTINE MC13D(N,ICN,LICN,IP,LENR,IOR,IB,NUM,IW)                MC13D.5
C I IS THE IBM FORTRAN VERSION                                       IS/MC13D.3
C S IS THE STANDARD FORTRAN VERSION                                     MC13D.4
      INTEGER IP(N)
      INTEGER ICN(LICN),LENR(N),IOR(N),IB(N),IW(N,3)
      CALL MC13E(N,ICN,LICN,IP,LENR,IOR,IB,NUM,IW(1,1),IW(1,2),IW(1,3))
      RETURN
      END
      SUBROUTINE MC13E(N,ICN,LICN,IP,LENR,ARP,IB,NUM,LOWL,NUMB,PREV)    MC13D.12
      INTEGER STP,DUMMY
      INTEGER IP(N)
C                                                                       MC13D.15
C ARP(I) IS ONE LESS THAN THE NUMBER OF UNSEARCHED EDGES LEAVING        MC13D.16
C     NODE I.  AT THE END OF THE ALGORITHM IT IS SET TO A               MC13D.17
C     PERMUTATION WHICH PUTS THE MATRIX IN BLOCK LOWER                  MC13D.18
C     TRIANGULAR FORM.                                                  MC13D.19
C IB(I) IS THE POSITION IN THE ORDERING OF THE START OF THE ITH         MC13D.20
C     BLOCK.  IB(N+1-I) HOLDS THE NODE NUMBER OF THE ITH NODE           MC13D.21
C     ON THE STACK.                                                     MC13D.22
C LOWL(I) IS THE SMALLEST STACK POSITION OF ANY NODE TO WHICH A PATH    MC13D.23
C     FROM NODE I HAS BEEN FOUND.  IT IS SET TO N+1 WHEN NODE I         MC13D.24
C     IS REMOVED FROM THE STACK.                                        MC13D.25
C NUMB(I) IS THE POSITION OF NODE I IN THE STACK IF IT IS ON            MC13D.26
C     IT, IS THE PERMUTED ORDER OF NODE I FOR THOSE NODES               MC13D.27
C     WHOSE FINAL POSITION HAS BEEN FOUND AND IS OTHERWISE ZERO.        MC13D.28
C PREV(I) IS THE NODE AT THE END OF THE PATH WHEN NODE I WAS            MC13D.29
C     PLACED ON THE STACK.                                              MC13D.30
      INTEGER ICN(LICN),LENR(N),ARP(N),IB(N),LOWL(N),NUMB(N),
     APREV(N)
C                                                                       MC13D.35
C                                                                       MC13D.36
C   ICNT IS THE NUMBER OF NODES WHOSE POSITIONS IN FINAL ORDERING HAVE  MC13D.37
C     BEEN FOUND.                                                       MC13D.38
      ICNT=0
C NUM IS THE NUMBER OF BLOCKS THAT HAVE BEEN FOUND.                     MC13D.40
      NUM=0
      NNM1=N+N-1
C                                                                       MC13D.43
C INITIALIZATION OF ARRAYS.                                             MC13D.44
      DO 20 J=1,N
      NUMB(J)=0
      ARP(J)=LENR(J)-1
   20 CONTINUE
C                                                                       MC13D.49
C                                                                       MC13D.50
      DO 120 ISN=1,N
C LOOK FOR A STARTING NODE                                              MC13D.52
      IF (NUMB(ISN).NE.0) GO TO 120
      IV=ISN
C IST IS THE NUMBER OF NODES ON THE STACK ... IT IS THE STACK POINTER.  MC13D.55
      IST=1
C PUT NODE IV AT BEGINNING OF STACK.                                    MC13D.57
      LOWL(IV)=1
      NUMB(IV)=1
      IB(N)=IV
C                                                                       MC13D.61
C THE BODY OF THIS LOOP PUTS A NEW NODE ON THE STACK OR BACKTRACKS.     MC13D.62
      DO 110 DUMMY=1,NNM1
      I1=ARP(IV)
C HAVE ALL EDGES LEAVING NODE IV BEEN SEARCHED.                         MC13D.65
      IF (I1.LT.0) GO TO 60
      I2=IP(IV)+LENR(IV)-1
      I1=I2-I1
C                                                                       MC13D.69
C LOOK AT EDGES LEAVING NODE IV UNTIL ONE ENTERS A NEW NODE OR          MC13D.70
C     ALL EDGES ARE EXHAUSTED.                                          MC13D.71
      DO 50 II=I1,I2
      IW=ICN(II)
C HAS NODE IW BEEN ON STACK ALREADY.                                    MC13D.74
      IF (NUMB(IW).EQ.0) GO TO 100
C UPDATE VALUE OF LOWL(IV) IF NECESSARY.                                MC13D.76
C 50  LOWL(IV)=MIN0(LOWL(IV),LOWL(IW))                                S/MC13D.77
50    LOWL(IV)=MIN0(LOWL(IV),LOWL(IW))
C                                                                       MC13D.79
C THERE ARE NO MORE EDGES LEAVING NODE IV.                              MC13D.80
      ARP(IV)=-1
C IS NODE IV THE ROOT OF A BLOCK.                                       MC13D.82
   60 IF (LOWL(IV).LT.NUMB(IV)) GO TO 90
C                                                                       MC13D.84
C ORDER NODES IN A BLOCK.                                               MC13D.85
      NUM=NUM+1
      IST1=N+1-IST
      LCNT=ICNT+1
C PEEL BLOCK OFF THE TOP OF THE STACK STARTING AT THE TOP AND           MC13D.89
C     WORKING DOWN TO THE ROOT OF THE BLOCK.                            MC13D.90
      DO 70 STP=IST1,N
      IW=IB(STP)
      LOWL(IW)=N+1
      ICNT=ICNT+1
      NUMB(IW)=ICNT
      IF (IW.EQ.IV) GO TO 80
   70 CONTINUE
   80 IST=N-STP
      IB(NUM)=LCNT
C ARE THERE ANY NODES LEFT ON THE STACK.                                MC13D.10
      IF (IST.NE.0) GO TO 90
C HAVE ALL THE NODES BEEN ORDERED.                                      MC13D.10
      IF (ICNT.LT.N) GO TO 120
      GO TO 130
C                                                                       MC13D.10
C BACKTRACK TO PREVIOUS NODE ON PATH.                                   MC13D.10
   90 IW=IV
      IV=PREV(IV)
C UPDATE VALUE OF LOWL(IV) IF NECESSARY.                                MC13D.10
C     LOWL(IV)=MIN0(LOWL(IV),LOWL(IW))                                S/MC13D.11
      LOWL(IV)=MIN0(LOWL(IV),LOWL(IW))
      GO TO 110
C                                                                       MC13D.11
C PUT NEW NODE ON THE STACK.                                            MC13D.11
 100  ARP(IV)=I2-II-1
      PREV(IW)=IV
      IV=IW
      IST=IST+1
      LOWL(IV)=IST
      NUMB(IV)=IST
      K=N+1-IST
      IB(K)=IV
  110 CONTINUE
C                                                                       MC13D.12
  120 CONTINUE
C                                                                       MC13D.12
C                                                                       MC13D.12
C PUT PERMUTATION IN THE REQUIRED FORM.                                 MC13D.12
  130 DO 140 I=1,N
      II=NUMB(I)
 140  ARP(II)=I
      RETURN
      END
      SUBROUTINE MC22A(N,ICN,A,NZ,LENROW,IP,IQ,IW,IW1)                  MC22A.6
C I AND J ARE IBM FORTRAN SINGLE AND DOUBLE PRECISION CODES RESP.  IJSD/MC22A.3
C S AND D ARE STANDARD FORTRAN SINGLE AND DOUBLE PRECISION CODES RESP.  MC22A.4
C     SUBROUTINE MC22AD(N,ICN,A,NZ,LENROW,IP,IQ,IW,IW1)              DJ/MC22A.5
C     DOUBLE PRECISION A(NZ),AVAL                                    DJ/MC22A.7
      REAL A(NZ)
      INTEGER IW(N,2)
      INTEGER ICN(NZ),LENROW(N),IP(N),IQ( N),IW1(NZ)
      IF (NZ.LE.0) GO TO 1000
      IF (N.LE.0) GO TO 1000
C SET START OF ROW I IN IW(I,1) AND LENROW(I) IN IW(I,2)                MC22A.14
      IW(1,1)=1
      IW(1,2)=LENROW(1)
      DO 10 I=2,N
      IW(I,1)=IW(I-1,1)+LENROW(I-1)
 10   IW(I,2)=LENROW(I)
C PERMUTE LENROW ACCORDING TO IP.  SET OFF-SETS FOR NEW POSITION        MC22A.20
C     OF ROW IOLD IN IW(IOLD,1) AND PUT OLD ROW INDICES IN IW1 IN       MC22A.21
C     POSITIONS CORRESPONDING TO THE NEW POSITION OF THIS ROW IN A/ICN. MC22A.22
      JJ=1
      DO 20 I=1,N
      IOLD=IP(I)
      IOLD=IABS(IOLD)
      LENGTH=IW(IOLD,2)
      LENROW(I)=LENGTH
      IF (LENGTH.EQ.0) GO TO 20
      IW(IOLD,1)=IW(IOLD,1)-JJ
      J2=JJ+LENGTH-1
      DO 15 J=JJ,J2
 15   IW1(J)=IOLD
      JJ=J2+1
 20   CONTINUE
C SET INVERSE PERMUTATION TO IQ IN IW(.,2).                             MC22A.36
      DO 30 I=1,N
      IOLD=IQ(I)
      IOLD=IABS(IOLD)
 30   IW(IOLD,2)=I
C PERMUTE A AND ICN IN PLACE, CHANGING TO NEW COLUMN NUMBERS.           MC22A.41
C                                                                       MC22A.42
C ***   MAIN LOOP   ***                                                 MC22A.43
C EACH PASS THROUGH THIS LOOP PLACES A CLOSED CHAIN OF COLUMN INDICES   MC22A.44
C     IN THEIR NEW (AND FINAL) POSITIONS ... THIS IS RECORDED BY        MC22A.45
C     SETTING THE IW1 ENTRY TO ZERO SO THAT ANY WHICH ARE SUBSEQUENTLY  MC22A.46
C     ENCOUNTERED DURING THIS MAJOR SCAN CAN BE BYPASSED.               MC22A.47
      DO 200 I=1,NZ
      IOLD=IW1(I)
      IF (IOLD.EQ.0) GO TO 200
      IPOS=I
      JVAL=ICN(I)
C IF ROW IOLD IS IN SAME POSITIONS AFTER PERMUTATION GO TO 150.         MC22A.53
      IF (IW(IOLD,1).EQ.0) GO TO 150
      AVAL=A(I)
C **  CHAIN LOOP  **                                                    MC22A.56
C EACH PASS THROUGH THIS LOOP PLACES ONE (PERMUTED) COLUMN INDEX        MC22A.57
C     IN ITS FINAL POSITION  .. VIZ. IPOS.                              MC22A.58
      DO 100 ICHAIN=1,NZ
C NEWPOS IS THE ORIGINAL POSITION IN A/ICN OF THE ELEMENT TO BE PLACED  MC22A.60
C IN POSITION IPOS.  IT IS ALSO THE POSITION OF THE NEXT ELEMENT IN     MC22A.61
C     THE CHAIN.                                                        MC22A.62
      NEWPOS=IPOS+IW(IOLD,1)
C IS CHAIN COMPLETE '                                                   MC22A.64
      IF (NEWPOS.EQ.I) GO TO 130
      A(IPOS)=A(NEWPOS)
      JNUM=ICN(NEWPOS)
      ICN(IPOS)=IW(JNUM,2)
      IPOS=NEWPOS
      IOLD=IW1(IPOS)
      IW1(IPOS)=0
C **  END OF CHAIN LOOP  **                                             MC22A.72
 100  CONTINUE
 130  A(IPOS)=AVAL
 150  ICN(IPOS)=IW(JVAL,2)
C ***   END OF MAIN LOOP   ***                                          MC22A.76
 200  CONTINUE
C                                                                       MC22A.78
 1000 RETURN
      END
      SUBROUTINE MC23A(N,ICN,A,LICN,LENR,IDISP,IP,IQ,LENOFF,IW,IW1)     MC23A.6
C J AND I ARE IBM DOUBLE AND SINGLE VERSIONS.    IJSD/                  MC23A.3
C D AND S ARE STANDARD FORTRAN DOUBLE AND SINGLE VERSIONS.              MC23A.4
C     SUBROUTINE MC23AD(N,ICN,A,LICN,LENR,IDISP,IP,IQ,LENOFF,IW,IW1) JD/MC23A.5
C     DOUBLE PRECISION A(LICN)                                       JD/MC23A.7
      REAL A(LICN)
      INTEGER IDISP(2),IW1(N,2)
      LOGICAL ABORT
      INTEGER ICN(LICN),LENR(N),IP(N),IQ(N),LENOFF(N),IW(N,5)
C     COMMON /MC23BD/ LP,NUMNZ,NUM,LARGE,ABORT                       JD/MC23A.13
C INPUT ... N,ICN .. A,ICN,LENR ....                                    MC23A.14
C                                                                       MC23A.15
C SET UP POINTERS IW(.,1) TO THE BEGINNING OF THE ROWS AND SET LENOFF   MC23A.16
C     EQUAL TO LENR.                                                    MC23A.17
      COMMON /MC23B/ LP,NUMNZ,NUM,LARGE,ABORT
      IW1(1,1)=1
      LENOFF(1)=LENR(1)
      IF (N.EQ.1) GO TO 20
      DO 10 I=2,N
      LENOFF(I)=LENR(I)
   10 IW1(I,1)=IW1(I-1,1)+LENR(I-1)
C IDISP(1) POINTS TO THE FIRST POSITION IN A/ICN AFTER THE              MC23A.25
C     OFF-DIAGONAL BLOCKS AND UNTREATED ROWS.                           MC23A.26
   20 IDISP(1)=IW1(N,1)+LENR(N)
C                                                                       MC23A.28
C FIND ROW PERMUTATION IP TO MAKE DIAGONAL ZERO-FREE.                   MC23A.29
      CALL MC21A(N,ICN,LICN,IW1,LENR,IP,NUMNZ,IW)
C                                                                       MC23A.31
C POSSIBLE ERROR RETURN FOR STRUCTURALLY SINGULAR MATRICES.             MC23A.32
      IF (NUMNZ.NE.N.AND.ABORT) GO TO 170
C                                                                       MC23A.34
C IW1(.,2) AND LENR ARE PERMUTATIONS OF IW1(.,1) AND LENR/LENOFF        MC23A.35
C     SUITABLE FOR ENTRY                                                MC23A.36
C     TO MC13D SINCE MATRIX WITH THESE ROW POINTER AND LENGTH ARRAYS    MC23A.37
C     HAS MAXIMUM NUMBER OF NON-ZEROS ON THE DIAGONAL.                  MC23A.38
      DO 30 II=1,N
      I=IP(II)
      IW1(II,2)=IW1(I,1)
   30 LENR(II)=LENOFF(I)
C                                                                       MC23A.43
C FIND SYMMETRIC PERMUTATION IQ TO BLOCK LOWER TRIANGULAR FORM.         MC23A.44
      CALL MC13D(N,ICN,LICN,IW1(1,2),LENR,IQ,IW(1,4),NUM,IW)
C                                                                       MC23A.46
      IF (NUM.NE.1) GO TO 60
C                                                                       MC23A.48
C ACTION TAKEN IF MATRIX IS IRREDUCIBLE.                                MC23A.49
C WHOLE MATRIX IS JUST MOVED TO THE END OF THE STORAGE.                 MC23A.50
      DO 40 I=1,N
      LENR(I)=LENOFF(I)
      IP(I)=I
   40 IQ(I)=I
      LENOFF(1)=-1
C IDISP(1) IS THE FIRST POSITION AFTER THE LAST ELEMENT IN THE          MC23A.56
C     OFF-DIAGONAL BLOCKS AND UNTREATED ROWS.                           MC23A.57
      NZ=IDISP(1)-1
      IDISP(1)=1
C IDISP(2) IS THE POSITION IN A/ICN OF THE FIRST ELEMENT IN THE         MC23A.60
C     DIAGONAL BLOCKS.                                                  MC23A.61
      IDISP(2)=LICN-NZ+1
      LARGE=N
      IF (NZ.EQ.LICN) GO TO 230
      DO 50 K=1,NZ
      J=NZ-K+1
      JJ=LICN-K+1
      A(JJ)=A(J)
   50 ICN(JJ)=ICN(J)
C 230 = RETURN                                                          MC23A.70
      GO TO 230
C                                                                       MC23A.72
C DATA STRUCTURE REORDERED.                                             MC23A.73
C                                                                       MC23A.74
C FORM COMPOSITE ROW PERMUTATION ... IP(I) = IP(IQ(I)).                 MC23A.75
   60 DO 70 II=1,N
      I=IQ(II)
   70 IW(II,1)=IP(I)
      DO 80 I=1,N
   80 IP(I)=IW(I,1)
C                                                                       MC23A.81
C RUN THROUGH BLOCKS IN REVERSE ORDER SEPARATING DIAGONAL BLOCKS        MC23A.82
C     WHICH ARE MOVED TO THE END OF THE STORAGE.  ELEMENTS IN           MC23A.83
C     OFF-DIAGONAL BLOCKS ARE LEFT IN PLACE UNLESS A COMPRESS IS        MC23A.84
C     NECESSARY.                                                        MC23A.85
C                                                                       MC23A.86
C IBEG INDICATES THE LOWEST VALUE OF J FOR WHICH ICN(J) HAS BEEN        MC23A.87
C     SET TO ZERO WHEN ELEMENT IN POSITION J WAS MOVED TO THE           MC23A.88
C     DIAGONAL BLOCK PART OF STORAGE.                                   MC23A.89
      IBEG=LICN+1
C IEND IS THE POSITION OF THE FIRST ELEMENT OF THOSE TREATED ROWS       MC23A.91
C     WHICH ARE IN DIAGONAL BLOCKS.                                     MC23A.92
      IEND=LICN+1
C LARGE IS THE DIMENSION OF THE LARGEST BLOCK ENCOUNTERED SO FAR.       MC23A.94
      LARGE=0
C                                                                       MC23A.96
C NUM IS THE NUMBER OF DIAGONAL BLOCKS.                                 MC23A.97
      DO 150 K=1,NUM
      IBLOCK=NUM-K+1
C I1 IS FIRST ROW (IN PERMUTED FORM) OF BLOCK IBLOCK.                   MC23A.10
C I2 IS LAST ROW (IN PERMUTED FORM) OF BLOCK IBLOCK.                    MC23A.10
      I1=IW(IBLOCK,4)
      I2=N
      IF (K.NE.1) I2=IW(IBLOCK+1,4)-1
      LARGE=MAX0(LARGE,I2-I1+1)
C GO THROUGH THE ROWS OF BLOCK IBLOCK IN THE REVERSE ORDER.             MC23A.10
      DO 140 II=I1,I2
      INEW=I2-II+I1
C WE NOW DEAL WITH ROW INEW IN PERMUTED FORM (ROW IOLD IN ORIGINAL      MC23A.10
C     MATRIX).                                                          MC23A.11
      IOLD=IP(INEW)
C IF THERE IS SPACE TO MOVE UP DIAGONAL BLOCK PORTION OF ROW GO TO 110  MC23A.11
      IF (IEND-IDISP(1).GE.LENOFF(IOLD)) GO TO 110
C                                                                       MC23A.11
C IN-LINE COMPRESS.                                                     MC23A.11
C MOVES SEPARATED OFF-DIAGONAL ELEMENTS AND UNTREATED ROWS TO           MC23A.11
C     FRONT OF STORAGE.                                                 MC23A.11
      JNPOS=IBEG
      ILEND=IDISP(1)-1
      IF (ILEND.LT.IBEG) GO TO 190
      DO 90 J=IBEG,ILEND
      IF (ICN(J).EQ.0) GO TO 90
      ICN(JNPOS)=ICN(J)
      A(JNPOS)=A(J)
      JNPOS=JNPOS+1
   90 CONTINUE
      IDISP(1)=JNPOS
      IF (IEND-JNPOS.LT.LENOFF(IOLD)) GO TO 190
      IBEG=LICN+1
C RESET POINTERS TO THE BEGINNING OF THE ROWS.                          MC23A.13
      DO 100 I=2,N
  100 IW1(I,1)=IW1(I-1,1)+LENOFF(I-1)
C                                                                       MC23A.13
C ROW IOLD IS NOW SPLIT INTO DIAG. AND OFF-DIAG. PARTS.                 MC23A.13
  110 IROWB=IW1(IOLD,1)
      LENI=0
      IROWE=IROWB+LENOFF(IOLD)-1
C BACKWARD SCAN OF WHOLE OF ROW IOLD (IN ORIGINAL MATRIX).              MC23A.13
      IF (IROWE.LT.IROWB) GO TO 130
      DO 120 JJ=IROWB,IROWE
      J=IROWE-JJ+IROWB
      JOLD=ICN(J)
C IW(.,2) HOLDS THE INVERSE PERMUTATION TO IQ.                          MC23A.14
C     ..... IT WAS SET TO THIS IN MC13D.                                MC23A.14
      JNEW=IW(JOLD,2)
C IF (JNEW.LT.I1) THEN ....                                             MC23A.14
C ELEMENT IS IN OFF-DIAGONAL BLOCK AND SO IS LEFT IN SITU.              MC23A.14
      IF (JNEW.LT.I1) GO TO 120
C ELEMENT IS IN DIAGONAL BLOCK AND IS MOVED TO THE END OF THE STORAGE.  MC23A.14
      IEND=IEND-1
      A(IEND)=A(J)
      ICN(IEND)=JNEW
      IBEG=MIN0(IBEG,J)
      ICN(J)=0
      LENI=LENI+1
  120 CONTINUE
C                                                                       MC23A.15
      LENOFF(IOLD)=LENOFF(IOLD)-LENI
  130 LENR(INEW)=LENI
  140 CONTINUE
C                                                                       MC23A.16
      IP(I2)=-IP(I2)
  150 CONTINUE
C RESETS IP(N) TO POSITIVE VALUE.                                       MC23A.16
      IP(N)=-IP(N)
C IDISP(2) IS POSITION OF FIRST ELEMENT IN DIAGONAL BLOCKS.             MC23A.16
      IDISP(2)=IEND
C                                                                       MC23A.16
C THIS COMPRESS IS USED TO MOVE ALL OFF-DIAGONAL ELEMENTS TO THE        MC23A.16
C     FRONT OF THE STORAGE.                                             MC23A.17
      IF (IBEG.GT.LICN) GO TO 230
      JNPOS=IBEG
      ILEND=IDISP(1)-1
      DO 160 J=IBEG,ILEND
      IF (ICN(J).EQ.0) GO TO 160
      ICN(JNPOS)=ICN(J)
      A(JNPOS)=A(J)
      JNPOS=JNPOS+1
  160 CONTINUE
C IDISP(1) IS FIRST POSITION AFTER LAST ELEMENT OF OFF-DIAGONAL BLOCKS. MC23A.18
      IDISP(1)=JNPOS
      GO TO 230
C                                                                       MC23A.18
C                                                                       MC23A.18
C ERROR RETURN                                                          MC23A.18
  170 IF (LP.NE.0) WRITE(LP,180) NUMNZ
  180 FORMAT(33X,41H MATRIX IS STRUCTURALLY SINGULAR, RANK = ,I6)
      IDISP(1)=-1
      GO TO 210
  190 IF (LP.NE.0) WRITE(LP,200) N
  200 FORMAT(33X,33H LICN NOT BIG ENOUGH INCREASE BY ,I6)
      IDISP(1)=-2
  210 IF (LP.NE.0) WRITE(LP,220)
C 220 FORMAT(33H+ERROR RETURN FROM MC23AD BECAUSE)                   JD/MC23A.19
C                                                                       MC23A.19
  220 FORMAT(33H+ERROR RETURN FROM MC23A  BECAUSE)
  230 RETURN
      END
      SUBROUTINE MC24A(N,ICN,A,LICN,LENR,LENRL,W)                       MC24A.6
C J AND I ARE IBM DOUBLE AND SINGLE VERSIONS      IJSD/                 MC24A.3
C D AND S ARE STANDARD FORTRAN DOUBLE AND SINGLE VERSIONS.              MC24A.4
C     SUBROUTINE MC24AD(N,ICN,A,LICN,LENR,LENRL,W)                   JD/MC24A.5
C     DOUBLE PRECISION A(LICN),W(N),AMAXL,WROWL,AMAXU,ZERO           JD/MC24A.7
      REAL A(LICN),W(N)
      INTEGER ICN(LICN),LENR(N),LENRL(N)
C     DATA ZERO/0.0D0/                                               JD/MC24A.11
      DATA ZERO/0.0E0/
      AMAXL=ZERO
      DO 10 I=1,N
 10   W(I)=ZERO
      J0=1
      DO 100 I=1,N
      IF (LENR(I).EQ.0) GO TO 100
      J2=J0+LENR(I)-1
      IF (LENRL(I).EQ.0) GO TO 50
C CALCULATION OF 1-NORM OF L.                                           MC24A.21
      J1=J0+LENRL(I)-1
      WROWL=ZERO
      DO 30 JJ=J0,J1
C30   WROWL=WROWL+DABS(A(JJ))                                        JD/MC24A.25
C AMAXL IS THE MAXIMUM NORM OF COLUMNS OF L SO FAR FOUND.               MC24A.26
 30   WROWL=WROWL+ABS(A(JJ))
C     AMAXL=DMAX1(AMAXL,WROWL)                                       JD/MC24A.28
      AMAXL=AMAX1(AMAXL,WROWL)
      J0=J1+1
C CALCULATION OF NORMS OF COLUMNS OF U (MAX-NORMS).                     MC24A.31
 50   J0=J0+1
      IF (J0.GT.J2) GO TO 90
      DO 80 JJ=J0,J2
      J=ICN(JJ)
C80   W(J)=DMAX1(DABS(A(JJ)),W(J))                                   JD/MC24A.36
 80   W(J)=AMAX1(ABS(A(JJ)),W(J))
 90   J0=J2+1
 100  CONTINUE
C AMAXU IS SET TO MAXIMUM MAX-NORM OF COLUMNS OF U.                     MC24A.40
      AMAXU=ZERO
      DO 200 I=1,N
C200  AMAXU=DMAX1(AMAXU,W(I))                                        JD/MC24A.43
C GROFAC IS MAX U MAX-NORM TIMES MAX L 1-NORM.                          MC24A.44
 200  AMAXU=AMAX1(AMAXU,W(I))
      W(1)=AMAXL*AMAXU
      RETURN
      END
      SUBROUTINE MC21A(N,ICN,LICN,IP,LENR,IPERM,NUMNZ,IW)               MC21A.4
C I IS IBM SP AND S IS STANDARD SP    IS/                               MC21A.3
      INTEGER IP(N)
      INTEGER ICN(LICN),LENR(N),IPERM(N,5),IW(N,5)
      NP1=N+1
      CALL MC21B(N,ICN,LICN,IP,LENR,IPERM,NUMNZ,IW(1,1),IW(1,2),IW(1,3),
     AIW(1,4),IW(1,5),NP1)
      RETURN
      END
      SUBROUTINE MC21B(N,ICN,LICN,IP,LENR,IPERM,NUMNZ,PR,PREORD,ARP,    MC21A.13
     1CV,OUT,NP1)
      INTEGER IP(N)
C   PR(I) IS THE PREVIOUS ROW TO I IN THE DEPTH FIRST SEARCH.           MC21A.16
C IT IS USED AS A WORK ARRAY IN THE SORTING ALGORITHM.                  MC21A.17
C   ELEMENTS (IPERM(I),I) I=1, ... N  ARE NON-ZERO AT THE END OF THE    MC21A.18
C ALGORITHM UNLESS N ASSIGNMENTS HAVE NOT BEEN MADE.  IN WHICH CASE     MC21A.19
C (IPERM(I),I) WILL BE ZERO FOR N-NUMNZ ENTRIES.                        MC21A.20
C   CV(I) IS THE MOST RECENT ROW EXTENSION AT WHICH COLUMN I            MC21A.21
C WAS VISITED.                                                          MC21A.22
C   PREORD(I) IS THE ROW IN THE ORIGINAL MATRIX WHICH HAS THE           MC21A.23
C ITH SMALLEST NUMBER OF NON-ZEROS.                                     MC21A.24
C   ARP(I) IS ONE LESS THAN THE NUMBER OF NON-ZEROS IN ROW I            MC21A.25
C WHICH HAVE NOT BEEN SCANNED WHEN LOOKING FOR A CHEAP ASSIGNMENT.      MC21A.26
C   OUT(I) IS ONE LESS THAN THE NUMBER OF NON-ZEROS IN ROW I            MC21A.27
C WHICH HAVE NOT BEEN SCANNED DURING ONE PASS THROUGH THE MAIN LOOP.    MC21A.28
C     INTEGER ICN(LICN),LENR(N),IPERM(N),PR(N),CV(NP1),PREORD(N),  S/   MC21A.29
      INTEGER ICN(LICN),LENR(N),IPERM(N),PR(N),CV(NP1),PREORD(N),
     AARP(N),OUT(N)
C                                                                       MC21A.33
C   INITIALIZATION OF ARRAYS.                                           MC21A.34
      DO 10 I=1,N
      ARP(I)=LENR(I)-1
      CV(I)=0
   10 IPERM(I)=0
      CV(NP1)=0
      NUMNZ=0
C                                                                       MC21A.41
C   ROWS ORDERED IN ORDER OF INCREASING NUMBER OF NON-ZEROS, USING      MC21A.42
C LINKED LIST SORT INVOLVING O(N) OPERATIONS.                           MC21A.43
      DO 20 I=1,N
      IROW=LENR(I)+1
      PR(I)=CV(IROW)
   20 CV(IROW)=I
      NUM=1
      DO 40 I=1,NP1
      IPTR=CV(I)
      DO 30 J=1,N
      IF (IPTR.EQ.0) GO TO 40
      PREORD(NUM)=IPTR
      NUM=NUM+1
   30 IPTR=PR(IPTR)
   40 CV(I)=0
C                                                                       MC21A.57
C                                                                       MC21A.58
C   MAIN LOOP.                                                          MC21A.59
C   EACH PASS ROUND THIS LOOP EITHER RESULTS IN A NEW ASSIGNMENT        MC21A.60
C OR GIVES A ROW WITH NO ASSIGNMENT.                                    MC21A.61
      DO 130 JORD=1,N
      J=PREORD(JORD)
      PR(J)=-1
      DO 100 K=1,JORD
C LOOK FOR A CHEAP ASSIGNMENT                                           MC21A.66
      IN1=ARP(J)
      IF (IN1.LT.0) GO TO 60
      IN2=IP(J)+LENR(J)-1
      IN1=IN2-IN1
      DO 50 II=IN1,IN2
      I=ICN(II)
      IF (IPERM(I).EQ.0) GO TO 110
   50 CONTINUE
C   NO CHEAP ASSIGNMENT IN ROW.                                         MC21A.75
      ARP(J)=-1
C   BEGIN LOOKING FOR ASSIGNMENT CHAIN STARTING WITH ROW J.             MC21A.77
   60 OUT(J)=LENR(J)-1
C INNER LOOP.  EXTENDS CHAIN BY ONE OR BACKTRACKS.                      MC21A.79
      DO 90 KK=1,JORD
      IN1=OUT(J)
      IF (IN1.LT.0) GO TO 80
      IN2=IP(J)+LENR(J)-1
      IN1=IN2-IN1
C FORWARD SCAN.                                                         MC21A.85
      DO 70 II=IN1,IN2
      I=ICN(II)
      IF (CV(I).EQ.JORD) GO TO 70
C   COLUMN I HAS NOT YET BEEN ACCESSED DURING THIS PASS.                MC21A.89
      J1=J
      J=IPERM(I)
      CV(I)=JORD
      PR(J)=J1
      OUT(J1)=IN2-II-1
      GO TO 100
   70 CONTINUE
C                                                                       MC21A.97
C   BACKTRACKING STEP.                                                  MC21A.98
   80 J=PR(J)
      IF (J.EQ.-1) GO TO 130
   90 CONTINUE
C                                                                       MC21A.10
  100 CONTINUE
C                                                                       MC21A.10
C   NEW ASSIGNMENT IS MADE.                                             MC21A.10
  110 IPERM(I)=J
      ARP(J)=IN2-II-1
      NUMNZ=NUMNZ+1
      DO 120 K=1,JORD
      J=PR(J)
      IF (J.EQ.-1) GO TO 130
      II=IP(J)+LENR(J)-OUT(J)-2
      I=ICN(II)
      IPERM(I)=J
  120 CONTINUE
C                                                                       MC21A.11
  130 CONTINUE
C                                                                       MC21A.11
C   IF MATRIX IS STRUCTURALLY SINGULAR, WE NOW COMPLETE THE             MC21A.11
C PERMUTATION IPERM.                                                    MC21A.12
      IF (NUMNZ.EQ.N) RETURN
      DO 140 I=1,N
  140 ARP(I)=0
      K=0
      DO 160 I=1,N
      IF (IPERM(I).NE.0) GO TO 150
      K=K+1
      OUT(K)=I
      GO TO 160
  150 J=IPERM(I)
      ARP(J)=I
  160 CONTINUE
      K=0
      DO 170 I=1,N
      IF (ARP(I).NE.0) GO TO 170
      K=K+1
      IOUTK=OUT(K)
      IPERM(IOUTK)=I
  170 CONTINUE
      RETURN
      END
      SUBROUTINE MA30A(NN,ICN,A,LICN,LENR,LENRL,IDISP,IP,IQ,IRN,        MA30A.7
C I AND J ARE IBM FORTRAN SINGLE AND DOUBLE PRECISION CODES IJSD/       MA30A.3
C S AND D ARE STANDARD FORTRAN SINGLE AND DOUBLE PRECISION CODES RESP.  MA30A.4
C     SUBROUTINE MA30AD(NN,ICN,A,LICN,LENR,LENRL,IDISP,IP,IQ,IRN,    JD/MA30A.5
C    1LIRN,LENC,IFIRST,LASTR,NEXTR,LASTC,NEXTC,IPTR,IPC,U,IFLAG)     JD/MA30A.6
     1LIRN,LENC,IFIRST,LASTR,NEXTR,LASTC,NEXTC,IPTR,IPC,U,IFLAG)
C     DOUBLE PRECISION A(LICN),U,AU,UMAX,AMAX,ZERO                   JD/MA30A.9
      REAL A(LICN)
      INTEGER IPTR(NN),PIVOT,PIVEND,DISPC,OLDPIV,OLDEND,PIVROW
      INTEGER ROWI
      INTEGER IPC(NN),IDISP(2)
      LOGICAL ABORT1,ABORT2,ABORT3
      INTEGER ICN(LICN),LENR(NN),LENRL(NN),IP(NN),IQ(NN),LENC(NN),
     AIRN(LIRN)
      INTEGER IFIRST(NN),LASTR(NN),NEXTR(NN),LASTC(NN),NEXTC(NN)
C     COMMON /MA30ED/ LP,ABORT1,ABORT2,ABORT3                        JD/MA30A.21
      COMMON /MA30E/ LP,ABORT1,ABORT2,ABORT3
C     COMMON /MA30FD/ IRNCP,ICNCP,IRANK,MINIRN,MINICN                JD/MA30A.23
      COMMON /MA30F/ IRNCP,ICNCP,IRANK,MINIRN,MINICN
C     DATA UMAX/.999999999D0/                                        JD/MA30A.25
      DATA UMAX/.9999/
C     DATA ZERO/0.0D0/                                               JD/MA30A.27
C                                                                       MA30A.28
      DATA ZERO/0.0/
      MINIRN=0
      MINICN=IDISP(1)-1
      MOREI=0
      IRANK=NN
      IRNCP=0
      ICNCP=0
      IFLAG=0
C RESET U IF NECESSARY.                                                 MA30A.37
C     U=DMIN1(U,UMAX)                                                JD/MA30A.38
      U=AMIN1(U,UMAX)
C     U=DMAX1(U,ZERO)                                                JD/MA30A.40
C IBEG IS THE POSITION OF THE NEXT PIVOT ROW AFTER ELIMINATION STEP     MA30A.41
C     USING IT.                                                         MA30A.42
      U=AMAX1(U,ZERO)
      IBEG=IDISP(1)
C IACTIV IS THE POSITION OF THE FIRST ENTRY IN THE ACTIVE PART OF A/ICN.MA30A.45
      IACTIV=IDISP(2)
C NZROW IS CURRENT NUMBER OF NON-ZEROS IN ACTIVE AND UNPROCESSED PART   MA30A.47
C     OF ROW FILE ICN.                                                  MA30A.48
      NZROW=LICN-IACTIV+1
      MINICN=NZROW+MINICN
C                                                                       MA30A.51
C COUNT THE NUMBER OF DIAGONAL BLOCKS AND SET UP POINTERS TO THE        MA30A.52
C     BEGINNINGS OF THE ROWS.                                           MA30A.53
C NUM IS THE NUMBER OF DIAGONAL BLOCKS.                                 MA30A.54
      NUM=1
      IPTR(1)=IACTIV
      IF (NN.EQ.1) GO TO 20
      NNM1=NN-1
      DO 10 I=1,NNM1
      IF (IP(I).LT.0) NUM=NUM+1
   10 IPTR(I+1)=IPTR(I)+LENR(I)
C ILAST IS THE LAST ROW IN THE PREVIOUS BLOCK.                          MA30A.62
   20 ILAST=0
C                                                                       MA30A.64
C ***********************************************                       MA30A.65
C ****    LU DECOMPOSITION OF BLOCK NBLOCK   ****                       MA30A.66
C ***********************************************                       MA30A.67
C                                                                       MA30A.68
C EACH PASS THROUGH THIS LOOP PERFORMS LU DECOMPOSITION ON ONE          MA30A.69
C     OF THE DIAGONAL BLOCKS.                                           MA30A.70
      DO 950 NBLOCK=1,NUM
      ISTART=ILAST+1
      DO 30 IROWS=ISTART,NN
      IF (IP(IROWS).LT.0) GO TO 40
   30 CONTINUE
      IROWS=NN
   40 ILAST=IROWS
C N IS THE NUMBER OF ROWS IN THE CURRENT BLOCK.                         MA30A.78
C ISTART IS THE INDEX OF THE FIRST ROW IN THE CURRENT BLOCK.            MA30A.79
C ILAST IS THE INDEX OF THE LAST ROW IN THE CURRENT BLOCK.              MA30A.80
C IACTIV IS THE POSITION OF THE FIRST ELEMENT IN THE BLOCK.             MA30A.81
C ITOP IS THE POSITION OF THE LAST ELEMENT IN THE BLOCK.                MA30A.82
      N=ILAST-ISTART+1
      IF (N.NE.1) GO TO 100
C                                                                       MA30A.85
C CODE FOR DEALING WITH 1X1 BLOCK.                                      MA30A.86
      LENRL(ILAST)=0
      ISING=ISTART
      IF (LENR(ILAST).NE.0) GO TO 60
C BLOCK IS STRUCTURALLY SINGULAR.                                       MA30A.90
      IRANK=IRANK-1
      ISING=-ISING
      IF (IFLAG.NE.2.AND.IFLAG.NE.-5) IFLAG=1
      IF (.NOT.ABORT1) GO TO 90
      IDISP(2)=IACTIV
      IFLAG=-1
      IF (LP.NE.0) WRITE(LP,50)
   50 FORMAT(67H ERROR RETURN FROM MA30A/AD BECAUSE MATRIX IS STRUCTURAL
     ALY SINGULAR)
C     RETURN                                                            MA30A.10
      GO TO 1110
   60 IF (A(IACTIV).NE.ZERO) GO TO 80
      ISING=-ISING
      IRANK=IRANK-1
      IPTR(ILAST)=0
      IF (IFLAG.NE.-5) IFLAG=2
      IF (.NOT.ABORT2) GO TO 80
      IDISP(2)=IACTIV
      IFLAG=-2
      IF (LP.NE.0) WRITE(LP,70)
   70 FORMAT(66H ERROR RETURN FROM MA30A/AD BECAUSE MATRIX IS NUMERICALL
     AY SINGULAR)
      GO TO 1110
   80 A(IBEG)=A(IACTIV)
      ICN(IBEG)=ICN(IACTIV)
      IACTIV=IACTIV+1
      IPTR(ISTART)=0
      IBEG=IBEG+1
      NZROW=NZROW-1
   90 LASTR(ISTART)=ISTART
      LASTC(ISTART)=ISING
      GO TO 950
C                                                                       MA30A.12
C NON-TRIVIAL BLOCK.                                                    MA30A.12
  100 ITOP=LICN
      IF (ILAST.NE.NN) ITOP=IPTR(ILAST+1)-1
C                                                                       MA30A.12
C SET UP COLUMN ORIENTED STORAGE.                                       MA30A.12
      DO 110 I=ISTART,ILAST
      LENRL(I)=0
  110 LENC(I)=0
      IF (ITOP-IACTIV.LT.LIRN) GO TO 120
      MINIRN=ITOP-IACTIV+1
      PIVOT=ISTART-1
      GO TO 1050
C                                                                       MA30A.13
C CALCULATE COLUMN COUNTS.                                              MA30A.13
  120 DO 130 II=IACTIV,ITOP
      I=ICN(II)
  130 LENC(I)=LENC(I)+1
C SET UP COLUMN POINTERS SO THAT IPC(J) POINTS TO POSITION AFTER END    MA30A.14
C     OF COLUMN J IN COLUMN FILE.                                       MA30A.14
      IPC(ILAST)=LIRN+1
      J1=ISTART+1
      DO 140 JJ=J1,ILAST
      J=ILAST-JJ+J1-1
  140 IPC(J)=IPC(J+1)-LENC(J+1)
      DO 160 INDROW=ISTART,ILAST
      J1=IPTR(INDROW)
      J2=J1+LENR(INDROW)-1
      IF (J1.GT.J2) GO TO 160
      DO 150 JJ=J1,J2
      J=ICN(JJ)
      IPOS=IPC(J)-1
      IRN(IPOS)=INDROW
      IPC(J)=IPOS
  150 CONTINUE
  160 CONTINUE
C DISPC IS THE LOWEST INDEXED ACTIVE LOCATION IN THE COLUMN FILE.       MA30A.15
      DISPC=IPC(ISTART)
      NZCOL=LIRN-DISPC+1
      MINIRN=MAX0(NZCOL,MINIRN)
      NZMIN=1
C                                                                       MA30A.16
C INITIALIZE ARRAY IFIRST.  IFIRST(I) = +/- K INDICATES THAT ROW/COL    MA30A.16
C     K HAS I NON-ZEROS.  IF IFIRST(I) = 0, THERE IS NO ROW OR COLUMN   MA30A.16
C     WITH I NON ZEROS.                                                 MA30A.16
      DO 170 I=1,N
  170 IFIRST(I)=0
C                                                                       MA30A.17
C COMPUTE ORDERING OF ROW AND COLUMN COUNTS.                            MA30A.17
C FIRST RUN THROUGH COLUMNS (FROM COLUMN N TO COLUMN 1).                MA30A.17
      DO 190 JJ=ISTART,ILAST
      J=ILAST-JJ+ISTART
      NZ=LENC(J)
      IF (NZ.NE.0) GO TO 180
      IPC(J)=0
      LASTC(J)=0
      GO TO 190
  180 ISW=IFIRST(NZ)
      IFIRST(NZ)=-J
      LASTC(J)=0
      NEXTC(J)=-ISW
      ISW1=IABS(ISW)
      IF (ISW.NE.0) LASTC(ISW1)=J
  190 CONTINUE
C NOW RUN THROUGH ROWS (AGAIN FROM N TO 1).                             MA30A.18
      DO 210 II=ISTART,ILAST
      I=ILAST-II+ISTART
      NZ=LENR(I)
      IF (NZ.NE.0) GO TO 200
      IPTR(I)=0
      LASTR(I)=0
      GO TO 210
  200 ISW=IFIRST(NZ)
      IFIRST(NZ)=I
      IF (ISW.GT.0) GO TO 205
      NEXTR(I)=0
      LASTR(I)=ISW
      GO TO 210
 205  NEXTR(I)=ISW
      LASTR(I)=LASTR(ISW)
      LASTR(ISW)=I
  210 CONTINUE
C                                                                       MA30A.20
C                                                                       MA30A.20
C **********************************************                        MA30A.20
C ****    START OF MAIN ELIMINATION LOOP    ****                        MA30A.20
C **********************************************                        MA30A.20
      DO 930 PIVOT=ISTART,ILAST
C                                                                       MA30A.21
C FIRST FIND THE PIVOT USING MARKOWITZ CRITERION WITH STABILITY         MA30A.21
C     CONTROL.                                                          MA30A.21
C JCOST IS THE MARKOWITZ COST OF THE BEST PIVOT SO FAR,.. THIS          MA30A.21
C     PIVOT IS IN ROW IPIV AND COLUMN JPIV.                             MA30A.21
      NZ2=NZMIN
      JCOST=N*N
C                                                                       MA30A.21
C EXAMINE ROWS/COLUMNS IN ORDER OF ASCENDING COUNT.                     MA30A.21
      DO 290 L=1,2
      LL=L
C A PASS WITH L EQUAL TO 2 IS ONLY PERFORMED IN THE CASE OF SINGULARITY.MA30A.22
      DO 280 NZ=NZ2,N
      IF (JCOST.LE.(NZ-1)**2) GO TO 380
      IJFIR=IFIRST(NZ)
      IF (IJFIR) 212,211,215
 211  IF (LL.EQ.1) NZMIN=NZ+1
      GO TO 280
 212  LL=2
      IJFIR=-IJFIR
      GO TO 245
 215  LL=2
C SCAN ROWS WITH NZ NON-ZEROS.                                          MA30A.23
      DO 235 IDUMMY=1,N
      IF (IJFIR.EQ.0) GO TO 240
C ROW IJFIR IS NOW EXAMINED.                                            MA30A.23
      I=IJFIR
      IJFIR=NEXTR(I)
      AMAX=ZERO
      J1=IPTR(I)+LENRL(I)
      J2=IPTR(I)+LENR(I)-1
      DO 220 JJ=J1,J2
C 220 AMAX=DMAX1(AMAX,DABS(A(JJ)))                                   JD/MA30A.24
 220  AMAX=AMAX1(AMAX,ABS(A(JJ)))
      AU=AMAX*U
C SCAN ROW FOR POSSIBLE PIVOTS                                          MA30A.24
      DO 230 JJ=J1,J2
C     IF (DABS(A(JJ)).LE.AU.AND.L.EQ.1) GO TO 230                    JD/MA30A.24
      IF (ABS(A(JJ)).LE.AU.AND.L.EQ.1) GO TO 230
      J=ICN(JJ)
      KCOST=(NZ-1)*(LENC(J)-1)
      IF (KCOST.GE.JCOST) GO TO 230
C BEST PIVOT SO FAR IS FOUND.                                           MA30A.25
      JCOST=KCOST
      IJPOS=JJ
      IPIV=I
      JPIV=J
      IF (JCOST.LE.(NZ-1)**2) GO TO 380
  230 CONTINUE
 235  CONTINUE
C                                                                       MA30A.26
C COLUMNS WITH NZ NON-ZEROS NOW EXAMINED.                               MA30A.26
 240  IJFIR=IFIRST(NZ)
      IJFIR=-LASTR(IJFIR)
 245  IF (JCOST.LE.NZ*(NZ-1)) GO TO 380
      DO 270 IDUMMY=1,N
      IF (IJFIR.EQ.0) GO TO 280
      J=IJFIR
      IJFIR=NEXTC(IJFIR)
      I1=IPC(J)
      I2=I1+NZ-1
C SCAN COLUMN J.                                                        MA30A.27
      DO 260 II=I1,I2
      I=IRN(II)
      KCOST=(NZ-1)*(LENR(I)-LENRL(I)-1)
      IF (KCOST.GE.JCOST) GO TO 260
C PIVOT HAS BEST MARKOWITZ COUNT SO FAR ... NOW CHECK ITS               MA30A.27
C     SUITABILITY ON NUMERIC GROUNDS BY EXAMINING THE OTHER NON-ZEROS   MA30A.27
C     IN ITS ROW.                                                       MA30A.28
      J1=IPTR(I)+LENRL(I)
      J2=IPTR(I)+LENR(I)-1
C WE NEED A STABILITY CHECK ON SINGLETON COLUMNS BECAUSE OF POSSIBLE    MA30A.28
C     PROBLEMS WITH UNDERDETERMINED SYSTEMS.                            MA30A.28
      AMAX=ZERO
      DO 250 JJ=J1,J2
C     AMAX=DMAX1(AMAX,DABS(A(JJ)))                                   JD/MA30A.28
      AMAX=AMAX1(AMAX,ABS(A(JJ)))
  250 IF (ICN(JJ).EQ.J) JPOS=JJ
C     IF (DABS(A(JPOS)).LE.AMAX*U.AND.L.EQ.1) GO TO 260              JD/MA30A.29
      IF (ABS(A(JPOS)).LE.AMAX*U.AND.L.EQ.1) GO TO 260
      JCOST=KCOST
      IPIV=I
      JPIV=J
      IJPOS=JPOS
      IF (JCOST.LE.NZ*(NZ-1)) GO TO 380
  260 CONTINUE
C                                                                       MA30A.29
  270 CONTINUE
C                                                                       MA30A.30
  280 CONTINUE
C                                                                       MA30A.30
C MATRIX IS NUMERICALLY OR STRUCTURALLY SINGULAR  ... WHICH IT IS WILL  MA30A.30
C     BE DIAGNOSED LATER.                                               MA30A.30
      IRANK=IRANK-1
  290 CONTINUE
C ASSIGN REST OF ROWS AND COLUMNS TO ORDERING ARRAY.                    MA30A.30
C MATRIX IS STRUCTURALLY SINGULAR.                                      MA30A.30
      IF (IFLAG.NE.2.AND.IFLAG.NE.-5) IFLAG=1
      IRANK=IRANK-ILAST+PIVOT+1
      IF (.NOT.ABORT1) GO TO 300
      IDISP(2)=IACTIV
      IFLAG=-1
      IF (LP.NE.0) WRITE(LP,50)
      GO TO 1110
  300 K=PIVOT-1
      DO 350 I=ISTART,ILAST
      IF (LASTR(I).NE.0) GO TO 350
      K=K+1
      LASTR(I)=K
      IF (LENRL(I).EQ.0) GO TO 340
      MINICN=MAX0(MINICN,NZROW+IBEG-1+MOREI+LENRL(I))
      IF (IACTIV-IBEG.GE.LENRL(I)) GO TO 320
C     CALL MA30DD(A,ICN,IPTR(ISTART),N,IACTIV,ITOP,.TRUE.)           JD/MA30A.32
C CHECK NOW TO SEE IF MA30D/DD HAS CREATED ENOUGH AVAILABLE SPACE.      MA30A.32
      CALL MA30D(A,ICN,IPTR(ISTART),N,IACTIV,ITOP,.TRUE.)
      IF (IACTIV-IBEG.GE.LENRL(I)) GO TO 320
C CREATE MORE SPACE BY DESTROYING PREVIOUSLY CREATED LU FACTORS.        MA30A.32
      MOREI=MOREI+IBEG-IDISP(1)
      IBEG=IDISP(1)
      IF (LP.NE.0) WRITE(LP,310)
      IFLAG=-5
  310 FORMAT(48H LU DECOMPOSITION DESTROYED TO CREATE MORE SPACE)
      IF (ABORT3) GO TO 1030
  320 J1=IPTR(I)
      J2=J1+LENRL(I)-1
      IPTR(I)=0
      DO 330 JJ=J1,J2
      A(IBEG)=A(JJ)
      ICN(IBEG)=ICN(JJ)
      ICN(JJ)=0
  330 IBEG=IBEG+1
      NZROW=NZROW-LENRL(I)
  340 IF (K.EQ.ILAST) GO TO 360
  350 CONTINUE
  360 K=PIVOT-1
      DO 370 I=ISTART,ILAST
      IF (LASTC(I).NE.0) GO TO 370
      K=K+1
      LASTC(I)=-K
      IF (K.EQ.ILAST) GO TO 940
  370 CONTINUE
C                                                                       MA30A.35
C THE PIVOT HAS NOW BEEN FOUND IN POSITION (IPIV,JPIV) IN LOCATION      MA30A.35
C     IJPOS IN ROW FILE.                                                MA30A.35
C UPDATE COLUMN AND ROW ORDERING ARRAYS TO CORRESPOND WITH REMOVAL      MA30A.35
C     OF THE ACTIVE PART OF THE MATRIX.                                 MA30A.35
  380 ISING=PIVOT
      IF (A(IJPOS).NE.ZERO) GO TO 390
C NUMERICAL SINGULARITY IS RECORDED HERE.                               MA30A.36
      ISING=-ISING
      IF (IFLAG.NE.-5) IFLAG=2
      IF (.NOT.ABORT2) GO TO 390
      IDISP(2)=IACTIV
      IFLAG=-2
      IF (LP.NE.0) WRITE(LP,70)
      GO TO 1110
  390 OLDPIV=IPTR(IPIV)+LENRL(IPIV)
      OLDEND=IPTR(IPIV)+LENR(IPIV)-1
C CHANGES TO COLUMN ORDERING.                                           MA30A.37
      DO 460 JJ=OLDPIV,OLDEND
      J=ICN(JJ)
      LC=LASTC(J)
      NC=NEXTC(J)
      IF (NC.NE.0) LASTC(NC)=LC
      IF (LC.EQ.0) GO TO 440
      NEXTC(LC)=NC
      GO TO 460
 440  NZ=LENC(J)
      ISW=IFIRST(NZ)
      IF (ISW.GT.0) LASTR(ISW)=-NC
      IF (ISW.LT.0) IFIRST(NZ)=-NC
  460 CONTINUE
C CHANGES TO ROW ORDERING.                                              MA30A.38
      I1=IPC(JPIV)
      I2=I1+LENC(JPIV)-1
      DO 530 II=I1,I2
      I=IRN(II)
      LR=LASTR(I)
      NR=NEXTR(I)
      IF (NR.NE.0) LASTR(NR)=LR
      IF (LR.LE.0) GO TO 500
      NEXTR(LR)=NR
      GO TO 530
 500  NZ=LENR(I)-LENRL(I)
      IF (NR.NE.0) IFIRST(NZ)=NR
      IF (NR.EQ.0) IFIRST(NZ)=LR
  530 CONTINUE
C     RECORD THE COLUMN PERMUTATION IN LASTC(JPIV) AND THE ROW          MA30A.39
C     PERMUTATION IN LASTR(IPIV).                                       MA30A.40
      LASTC(JPIV)=ISING
      LASTR(IPIV)=PIVOT
C                                                                       MA30A.40
C MOVE PIVOT TO POSITION LENRL+1 IN PIVOT ROW AND MOVE PIVOT ROW        MA30A.40
C     TO THE BEGINNING OF THE AVAILABLE STORAGE.                        MA30A.40
C THE L PART AND THE PIVOT IN THE OLD COPY OF THE PIVOT ROW IS          MA30A.40
C     NULLIFIED WHILE, IN THE STRICTLY UPPER TRIANGULAR PART, THE       MA30A.40
C     COLUMN INDICES, J SAY, ARE OVERWRITTEN BY THE CORRESPONDING       MA30A.40
C     ELEMENT OF IQ (IQ(J)) AND IQ(J) IS SET TO THE NEGATIVE OF THE     MA30A.40
C     DISPLACEMENT OF THE COLUMN INDEX FROM THE PIVOT ELEMENT.          MA30A.41
      IF (OLDPIV.EQ.IJPOS) GO TO 540
      AU=A(OLDPIV)
      A(OLDPIV)=A(IJPOS)
      A(IJPOS)=AU
      ICN(IJPOS)=ICN(OLDPIV)
      ICN(OLDPIV)=JPIV
C CHECK TO SEE IF THERE IS SPACE IMMEDIATELY AVAILABLE IN A/ICN TO      MA30A.41
C     HOLD NEW COPY OF PIVOT ROW.                                       MA30A.41
  540 MINICN=MAX0(MINICN,NZROW+IBEG-1+MOREI+LENR(IPIV))
      IF (IACTIV-IBEG.GE.LENR(IPIV)) GO TO 550
C     CALL MA30DD(A,ICN,IPTR(ISTART),N,IACTIV,ITOP,.TRUE.)           JD/MA30A.42
      CALL MA30D(A,ICN,IPTR(ISTART),N,IACTIV,ITOP,.TRUE.)
      OLDPIV=IPTR(IPIV)+LENRL(IPIV)
      OLDEND=IPTR(IPIV)+LENR(IPIV)-1
C CHECK NOW TO SEE IF MA30D/DD HAS CREATED ENOUGH AVAILABLE SPACE.      MA30A.42
      IF (IACTIV-IBEG.GE.LENR(IPIV)) GO TO 550
C CREATE MORE SPACE BY DESTROYING PREVIOUSLY CREATED LU FACTORS.        MA30A.42
      MOREI=MOREI+IBEG-IDISP(1)
      IBEG=IDISP(1)
      IF (LP.NE.0) WRITE(LP,310)
      IFLAG=-5
      IF (ABORT3) GO TO 1030
      IF (IACTIV-IBEG.GE.LENR(IPIV)) GO TO 550
C THERE IS STILL NOT ENOUGH ROOM IN A/ICN.                              MA30A.43
      IFLAG=-4
      GO TO 1030
C COPY PIVOT ROW AND SET UP IQ ARRAY.                                   MA30A.43
  550 IJPOS=0
      J1=IPTR(IPIV)
C                                                                       MA30A.44
      DO 570 JJ=J1,OLDEND
      A(IBEG)=A(JJ)
      ICN(IBEG)=ICN(JJ)
      IF (IJPOS.NE.0) GO TO 560
      IF (ICN(JJ).EQ.JPIV) IJPOS=IBEG
      ICN(JJ)=0
      GO TO 570
  560 K=IBEG-IJPOS
      J=ICN(JJ)
      ICN(JJ)=IQ(J)
      IQ(J)=-K
  570 IBEG=IBEG+1
C                                                                       MA30A.45
      IJP1=IJPOS+1
      PIVEND=IBEG-1
      LENPIV=PIVEND-IJPOS
      NZROW=NZROW-LENRL(IPIV)-1
      IPTR(IPIV)=OLDPIV+1
      IF (LENPIV.EQ.0) IPTR(IPIV)=0
C                                                                       MA30A.46
C REMOVE PIVOT ROW (INCLUDING PIVOT) FROM COLUMN ORIENTED FILE.         MA30A.46
      DO 600 JJ=IJPOS,PIVEND
      J=ICN(JJ)
      I1=IPC(J)
      LENC(J)=LENC(J)-1
C I2 IS LAST POSITION IN NEW COLUMN.                                    MA30A.46
      I2=IPC(J)+LENC(J)-1
      IF (I2.LT.I1) GO TO 590
      DO 580 II=I1,I2
      IF (IRN(II).NE.IPIV) GO TO 580
      IRN(II)=IRN(I2+1)
      GO TO 590
  580 CONTINUE
  590 IRN(I2+1)=0
  600 CONTINUE
      NZCOL=NZCOL-LENPIV-1
C                                                                       MA30A.47
C GO DOWN THE PIVOT COLUMN AND FOR EACH ROW WITH A NON-ZERO ADD         MA30A.47
C     THE APPROPRIATE MULTIPLE OF THE PIVOT ROW TO IT.                  MA30A.47
C WE LOOP ON THE NUMBER OF NON-ZEROS IN THE PIVOT COLUMN SINCE          MA30A.48
C     MA30D/DD MAY CHANGE ITS ACTUAL POSITION.                          MA30A.48
C                                                                       MA30A.48
      NZPC=LENC(JPIV)
      IF (NZPC.EQ.0) GO TO 870
      DO 820 III=1,NZPC
      II=IPC(JPIV)+III-1
      I=IRN(II)
C SEARCH ROW I FOR NON-ZERO TO BE ELIMINATED, CALCULATE MULTIPLIER,     MA30A.48
C     AND PLACE IT IN POSITION LENRL+1 IN ITS ROW.                      MA30A.48
      J1=IPTR(I)+LENRL(I)
      IEND=IPTR(I)+LENR(I)-1
      DO 610 JJ=J1,IEND
      IF (ICN(JJ).NE.JPIV) GO TO 610
C IF PIVOT IS ZERO, REST OF COLUMN IS AND SO MULTIPLIER IS ZERO.        MA30A.49
      AU=ZERO
      IF (A(IJPOS).NE.ZERO) AU=-A(JJ)/A(IJPOS)
      ICN(JJ)=ICN(J1)
      ICN(J1)=JPIV
      A(JJ)=A(J1)
      A(J1)=AU
      LENRL(I)=LENRL(I)+1
      GO TO 620
  610 CONTINUE
C GO TO 870 IF PIVOT ROW IS A SINGLETON.                                MA30A.50
  620 IF (LENPIV.EQ.0) GO TO 820
C NOW PERFORM NECESSARY OPERATIONS ON REST OF NON-PIVOT ROW I.          MA30A.50
      ROWI=J1+1
      IOP=0
C IF ALL THE PIVOT ROW CAUSES FILL-IN GO TO 640                         MA30A.50
      IF (ROWI.GT.IEND) GO TO 640
C PERFORM OPERATIONS ON CURRENT NON-ZEROS IN ROW I.                     MA30A.51
C INNERMOST LOOP.                                                       MA30A.51
      DO 630 JJ=ROWI,IEND
      J=ICN(JJ)
      IF (IQ(J).GT.0) GO TO 630
      IOP=IOP+1
      PIVROW=IJPOS-IQ(J)
      A(JJ)=A(JJ)+AU*A(PIVROW)
      ICN(PIVROW)=-ICN(PIVROW)
  630 CONTINUE
  640 IFILL=LENPIV-IOP
C IF THERE IS NO FILL-IN GO TO 740.                                     MA30A.52
      IF (IFILL.EQ.0) GO TO 740
C NOW FOR THE FILL-IN.                                                  MA30A.52
      MINICN=MAX0(MINICN,MOREI+IBEG-1+NZROW+IFILL+LENR(I))
C SEE IF THERE IS ROOM FOR FILL-IN.                                     MA30A.52
C GET MAXIMUM SPACE FOR ROW I IN SITU.                                  MA30A.52
      DO 650 JDIFF=1,IFILL
      JNPOS=IEND+JDIFF
      IF (JNPOS.GT.LICN) GO TO 660
      IF (ICN(JNPOS).NE.0) GO TO 660
  650 CONTINUE
C THERE IS ROOM FOR ALL THE FILL-IN AFTER THE END OF THE ROW SO IT      MA30A.53
C     CAN BE LEFT IN SITU.                                              MA30A.53
C NEXT AVAILABLE SPACE FOR FILL-IN.                                     MA30A.53
      IEND=IEND+1
      GO TO 740
C JMORE SPACES FOR FILL-IN ARE REQUIRED IN FRONT OF ROW.                MA30A.53
  660 JMORE=IFILL-JDIFF+1
      I1=IPTR(I)
C WE NOW LOOK IN FRONT OF THE ROW TO SEE IF THERE IS SPACE FOR          MA30A.54
C     THE REST OF THE FILL-IN.                                          MA30A.54
      DO 670 JDIFF=1,JMORE
      JNPOS=I1-JDIFF
      IF (JNPOS.LT.IACTIV) GO TO 680
      IF (ICN(JNPOS).NE.0) GO TO 690
  670 CONTINUE
  680 JNPOS=I1-JMORE
      GO TO 700
C WHOLE ROW MUST BE MOVED TO THE BEGINNING OF AVAILABLE STORAGE.        MA30A.55
  690 JNPOS=IACTIV-LENR(I)-IFILL
C IF THERE IS SPACE IMMEDIATELY AVAILABLE FOR THE SHIFTED ROW GO TO 720.MA30A.55
  700 IF (JNPOS.GE.IBEG) GO TO 720
C     CALL MA30DD(A,ICN,IPTR(ISTART),N,IACTIV,ITOP,.TRUE.)           JD/MA30A.55
      CALL MA30D(A,ICN,IPTR(ISTART),N,IACTIV,ITOP,.TRUE.)
      I1=IPTR(I)
      IEND=I1+LENR(I)-1
      JNPOS=IACTIV-LENR(I)-IFILL
      IF (JNPOS.GE.IBEG) GO TO 720
C NO SPACE AVAILABLE SO TRY TO CREATE SOME BY THROWING AWAY PREVIOUS    MA30A.56
C     LU DECOMPOSITION.                                                 MA30A.56
      MOREI=MOREI+IBEG-IDISP(1)-LENPIV-1
      IF (LP.NE.0) WRITE(LP,310)
      IFLAG=-5
      IF (ABORT3) GO TO 1030
C KEEP RECORD OF CURRENT PIVOT ROW.                                     MA30A.56
      IBEG=IDISP(1)
      ICN(IBEG)=JPIV
      A(IBEG)=A(IJPOS)
      IJPOS=IBEG
      DO 710 JJ=IJP1,PIVEND
      IBEG=IBEG+1
      A(IBEG)=A(JJ)
  710 ICN(IBEG)=ICN(JJ)
      IJP1=IJPOS+1
      PIVEND=IBEG
      IBEG=IBEG+1
      IF (JNPOS.GE.IBEG) GO TO 720
C THIS STILL DOES NOT GIVE ENOUGH ROOM.                                 MA30A.57
      IFLAG=-4
      GO TO 1030
  720 IACTIV=MIN0(IACTIV,JNPOS)
C MOVE NON-PIVOT ROW I.                                                 MA30A.58
      IPTR(I)=JNPOS
      DO 730 JJ=I1,IEND
      A(JNPOS)=A(JJ)
      ICN(JNPOS)=ICN(JJ)
      JNPOS=JNPOS+1
  730 ICN(JJ)=0
C FIRST NEW AVAILABLE SPACE.                                            MA30A.59
      IEND=JNPOS
  740 NZROW=NZROW+IFILL
C INNERMOST FILL-IN LOOP WHICH ALSO RESETS ICN.                         MA30A.59
      DO 810 JJ=IJP1,PIVEND
      J=ICN(JJ)
      IF (J.LT.0) GO TO 800
      A(IEND)=AU*A(JJ)
      ICN(IEND)=J
      IEND=IEND+1
C                                                                       MA30A.60
C PUT NEW ENTRY IN COLUMN FILE.                                         MA30A.60
      MINIRN=MAX0(MINIRN,NZCOL+LENC(J)+1)
      JEND=IPC(J)+LENC(J)
      JROOM=NZPC-III+1+LENC(J)
      IF (JEND.GT.LIRN) GO TO 750
      IF (IRN(JEND).EQ.0) GO TO 790
  750 IF (JROOM.LT.DISPC) GO TO 760
C COMPRESS COLUMN FILE TO OBTAIN SPACE FOR NEW COPY OF COLUMN.          MA30A.60
C     CALL MA30DD(A,IRN,IPC(ISTART),N,DISPC,LIRN,.FALSE.)            JD/MA30A.60
      CALL MA30D(A,IRN,IPC(ISTART),N,DISPC,LIRN,.FALSE.)
      IF (JROOM.LT.DISPC) GO TO 760
      JROOM=DISPC-1
      IF (JROOM.GE.LENC(J)+1) GO TO 760
C COLUMN FILE IS NOT LARGE ENOUGH.                                      MA30A.61
      GO TO 1050
C COPY COLUMN TO BEGINNING OF FILE.                                     MA30A.61
  760 JBEG=IPC(J)
      JEND=IPC(J)+LENC(J)-1
      JZERO=DISPC-1
      DISPC=DISPC-JROOM
      IDISPC=DISPC
      DO 770 II=JBEG,JEND
      IRN(IDISPC)=IRN(II)
      IRN(II)=0
  770 IDISPC=IDISPC+1
      IPC(J)=DISPC
      JEND=IDISPC
      DO 780 II=JEND,JZERO
  780 IRN(II)=0
  790 IRN(JEND)=I
      NZCOL=NZCOL+1
      LENC(J)=LENC(J)+1
C END OF ADJUSTMENT TO COLUMN FILE.                                     MA30A.63
      GO TO 810
C                                                                       MA30A.63
  800 ICN(JJ)=-J
  810 CONTINUE
      LENR(I)=LENR(I)+IFILL
C END OF SCAN OF PIVOT COLUMN.                                          MA30A.63
  820 CONTINUE
C                                                                       MA30A.64
C                                                                       MA30A.64
C REMOVE PIVOT COLUMN FROM COLUMN ORIENTED STORAGE AND UPDATE ROW       MA30A.64
C     ORDERING ARRAYS.                                                  MA30A.64
      I1=IPC(JPIV)
      I2=IPC(JPIV)+LENC(JPIV)-1
      NZCOL=NZCOL-LENC(JPIV)
      DO 860 II=I1,I2
      I=IRN(II)
      IRN(II)=0
      NZ=LENR(I)-LENRL(I)
      IF (NZ.NE.0) GO TO 830
      LASTR(I)=0
      GO TO 860
  830 IFIR=IFIRST(NZ)
      IFIRST(NZ)=I
      IF (IFIR) 840,855,850
 840  LASTR(I)=IFIR
      NEXTR(I)=0
      GO TO 860
 850  LASTR(I)=LASTR(IFIR)
      NEXTR(I)=IFIR
      LASTR(IFIR)=I
      GO TO 860
 855  LASTR(I)=0
      NEXTR(I)=0
      NZMIN=MIN0(NZMIN,NZ)
 860  CONTINUE
C RESTORE IQ AND NULLIFY U PART OF OLD PIVOT ROW.                       MA30A.66
  870 IPC(JPIV)=0
      IF (LENPIV.EQ.0) GO TO 930
      NZROW=NZROW-LENPIV
      JVAL=IJP1
      JZER=IPTR(IPIV)
      IPTR(IPIV)=0
      DO 880 JCOUNT=1,LENPIV
      J=ICN(JVAL)
      IQ(J)=ICN(JZER)
      ICN(JZER)=0
      JVAL=JVAL+1
  880 JZER=JZER+1
C ADJUST COLUMN ORDERING ARRAYS.                                        MA30A.68
      DO 920 JJ=IJP1,PIVEND
      J=ICN(JJ)
      NZ=LENC(J)
      IF (NZ.NE.0) GO TO 890
      LASTC(J)=0
      GO TO 920
  890 IFIR=IFIRST(NZ)
      LASTC(J)=0
      IF (IFIR) 900,910,915
 900  IFIRST(NZ)=-J
      IFIR=-IFIR
      LASTC(IFIR)=J
      NEXTC(J)=IFIR
      GO TO 920
 910  IFIRST(NZ)=-J
      NEXTC(J)=0
      NZMIN=MIN0(NZMIN,NZ)
      GO TO 920
 915  LC=-LASTR(IFIR)
      LASTR(IFIR)=-J
      NEXTC(J)=LC
      IF (LC.NE.0) LASTC(LC)=J
  920 CONTINUE
  930 CONTINUE
C ********************************************                          MA30A.70
C ****    END OF MAIN ELIMINATION LOOP    ****                          MA30A.70
C ********************************************                          MA30A.70
C                                                                       MA30A.71
C RESET IACTIV TO POINT TO THE BEGINNING OF THE NEXT BLOCK.             MA30A.71
  940 IF (ILAST.NE.NN) IACTIV=IPTR(ILAST+1)
  950 CONTINUE
C                                                                       MA30A.71
C ********************************************                          MA30A.71
C ****    END OF DEOMPOSITION OF BLOCK    ****                          MA30A.71
C ********************************************                          MA30A.71
C                                                                       MA30A.71
C RECORD SINGULARITY (IF ANY) IN IQ ARRAY.                              MA30A.71
      IF (IRANK.EQ.NN) GO TO 970
      DO 960 I=1,NN
      IF (LASTC(I).GT.0) GO TO 960
      ISING=-LASTC(I)
      IQ(ISING)=-IQ(ISING)
      LASTC(I)=ISING
  960 CONTINUE
C                                                                       MA30A.72
C RUN THROUGH LU DECOMPOSITION CHANGING COLUMN INDICES TO THAT OF NEW   MA30A.72
C     ORDER AND PERMUTING LENR AND LENRL ARRAYS ACCORDING TO PIVOT      MA30A.72
C     PERMUTATIONS.                                                     MA30A.73
  970 ISTART=IDISP(1)
      IEND=IBEG-1
      DO 980 JJ=ISTART,IEND
      JOLD=ICN(JJ)
  980 ICN(JJ)=LASTC(JOLD)
      DO 990 II=1,NN
      I=LASTR(II)
      NEXTR(I)=LENR(II)
  990 NEXTC(I)=LENRL(II)
      DO 1000 I=1,NN
      LENRL(I)=NEXTC(I)
 1000 LENR(I)=NEXTR(I)
C                                                                       MA30A.74
C UPDATE PERMUTATION ARRAYS IP AND IQ.                                  MA30A.74
      DO 1010 II=1,NN
      I=LASTR(II)
      J=LASTC(II)
      NEXTR(I)=IABS(IP(II))
1010  NEXTC(J)=IABS(IQ(II))
      DO 1020 I=1,NN
      IF (IP(I).LT.0) NEXTR(I)=-NEXTR(I)
      IP(I)=NEXTR(I)
      IF (IQ(I).LT.0) NEXTC(I)=-NEXTC(I)
 1020 IQ(I)=NEXTC(I)
      IP(NN)=IABS(IP(NN))
      IDISP(2)=IEND
      GO TO 1110
C                                                                       MA30A.75
C   ***    ERROR RETURNS    ***                                         MA30A.75
 1030 IDISP(2)=IACTIV
      IF (LP.EQ.0) GO TO 1110
      WRITE(LP,1040)
 1040 FORMAT(55H ERROR RETURN FROM MA30A/AD BECAUSE LICN NOT BIG ENOUGH)
      GO TO 1080
 1050 IF (IFLAG.EQ.-5) IFLAG=-6
      IF (IFLAG.NE.-6) IFLAG=-3
      IDISP(2)=IACTIV
      IF (LP.EQ.0) GO TO 1110
      IF (IFLAG.EQ.-3) WRITE(LP,1060)
      IF (IFLAG.EQ.-6) WRITE(LP,1070)
 1060 FORMAT(55H ERROR RETURN FROM MA30A/AD BECAUSE LIRN NOT BIG ENOUGH)
 1070 FORMAT(51H ERROR RETURN FROM MA30A/AD LIRN AND LICN TOO SMALL)
 1080 PIVOT=PIVOT-ISTART+1
      WRITE(LP,1090) PIVOT,NBLOCK,ISTART,ILAST
 1090 FORMAT(10H AT STAGE ,I5,10H IN BLOCK ,I5,16H WITH FIRST ROW ,I5,14
     AH AND LAST ROW ,I5)
      IF (PIVOT.EQ.0) WRITE(LP,1100) MINIRN
 1100 FORMAT(34H TO CONTINUE SET LIRN TO AT LEAST ,I8)
C                                                                       MA30A.77
C                                                                       MA30A.78
 1110 RETURN
      END
      SUBROUTINE MA30D(A,ICN,IPTR,N,IACTIV,ITOP,REALS)                  MA30A.78
C     SUBROUTINE MA30DD(A,ICN,IPTR,N,IACTIV,ITOP,REALS)              JD/MA30A.78
C     DOUBLE PRECISION A(ITOP)                                       JD/MA30A.78
      REAL A(ITOP)
      INTEGER IPTR(N)
      LOGICAL REALS
      INTEGER ICN(ITOP)
C     COMMON /MA30FD/ IRNCP,ICNCP,IRANK,MINIRN,MINICN                JD/MA30A.79
C IACTIV IS THE FIRST POSITION IN ARRAYS A/ICN FROM WHICH THE           MA30A.79
C     COMPRESS STARTS.                                                  MA30A.79
C ON EXIT IACTIV EQUALS THE POSITION OF THE FIRST ELEMENT IN THE        MA30A.79
C     COMPRESSED PART OF A/ICN                                          MA30A.79
      COMMON /MA30F/ IRNCP,ICNCP,IRANK,MINIRN,MINICN
      IF (REALS) ICNCP=ICNCP+1
      IF (.NOT.REALS) IRNCP=IRNCP+1
C SET THE FIRST NON-ZERO ELEMENT IN EACH ROW TO THE NEGATIVE OF THE     MA30A.79
C     ROW/COL NUMBER AND HOLD THIS ROW/COL INDEX IN THE ROW/COL         MA30A.80
C     POINTER.  THIS IS SO THAT THE BEGINNING OF EACH ROW/COL CAN       MA30A.80
C     BE RECOGNIZED IN THE SUBSEQUENT SCAN.                             MA30A.80
      DO 10 J=1,N
      K=IPTR(J)
      IF (K.LT.IACTIV) GO TO 10
      IPTR(J)=ICN(K)
      ICN(K)=-J
   10 CONTINUE
      KN=ITOP+1
      KL=ITOP-IACTIV+1
C GO THROUGH ARRAYS IN REVERSE ORDER COMPRESSING TO THE BACK SO         MA30A.81
C     THAT THERE ARE NO ZEROS HELD IN POSITIONS IACTIV TO ITOP IN ICN.  MA30A.81
C     RESET FIRST ELEMENT OF EACH ROW/COL AND POINTER ARRAY IPTR.       MA30A.81
      DO 30 K=1,KL
      JPOS=ITOP-K+1
      IF (ICN(JPOS).EQ.0) GO TO 30
      KN=KN-1
      IF (REALS) A(KN)=A(JPOS)
      IF (ICN(JPOS).GE.0) GO TO 20
C FIRST NON-ZERO OF ROW/COL HAS BEEN LOCATED                            MA30A.82
      J=-ICN(JPOS)
      ICN(JPOS)=IPTR(J)
      IPTR(J)=KN
   20 ICN(KN)=ICN(JPOS)
   30 CONTINUE
      IACTIV=KN
      RETURN
      END
      SUBROUTINE MA30B(N,ICN,A,LICN,LENR,LENRL,IDISP,IP,IQ,W,IW,        MA30A.83
C     SUBROUTINE MA30BD(N,ICN,A,LICN,LENR,LENRL,IDISP,IP,IQ,W,IW,    JD/MA30A.82
C    1IFLAG)                                                         JD/MA30A.83
     1IFLAG)
C     DOUBLE PRECISION A(LICN),W(N),AU,EPS,ROWMAX,ZERO,ONE,RMIN      JD/MA30A.83
      REAL A(LICN),W(N)
      INTEGER IW(N),IDISP(2),PIVPOS
      LOGICAL ABORT1,ABORT2,ABORT3,STAB
      INTEGER ICN(LICN),LENR(N),LENRL(N),IP(N),IQ(N)
C     COMMON /MA30ED/ LP,ABORT1,ABORT2,ABORT3                        JD/MA30A.83
      COMMON /MA30E/ LP,ABORT1,ABORT2,ABORT3
C     COMMON /MA30GD/ EPS,RMIN                                       JD/MA30A.84
      COMMON /MA30G/ EPS,RMIN
C     DATA ZERO/0.0D0/,ONE/1.0D0/                                    JD/MA30A.84
      DATA ZERO/0.0/,ONE/1.0/
      STAB=EPS.LE.ONE
      RMIN=EPS
      ISING=0
      IFLAG=0
C 170 = RETURN...                                                       MA30A.84
      IF (N.EQ.1) GO TO 170
      DO 10 I=1,N
   10 W(I)=ZERO
C SET UP POINTERS TO THE BEGINNING OF THE ROWS.                         MA30A.85
      IW(1)=IDISP(1)
      DO 20 I=2,N
   20 IW(I)=IW(I-1)+LENR(I-1)
C                                                                       MA30A.85
C   ****   START  OF MAIN LOOP    ****                                  MA30A.85
C AT STEP I, ROW I OF A IS TRANSFORMED TO ROW I OF L/U BY ADDING        MA30A.85
C     APPROPRIATE MULTIPLES OF ROWS 1 TO I-1.                           MA30A.86
C     .... USING ROW-GAUSS ELIMINATION.                                 MA30A.86
      DO 140 I=1,N
C ISTART IS BEGINNING OF ROW I OF A AND ROW I OF L.                     MA30A.86
      ISTART=IW(I)
C IFIN IS END OF ROW I OF A AND ROW I OF U.                             MA30A.86
      IFIN=ISTART+LENR(I)-1
C ILEND IS END OF ROW I OF L.                                           MA30A.86
      ILEND=ISTART+LENRL(I)-1
      IF (ISTART.GT.ILEND) GO TO 70
C LOAD ROW I OF A INTO VECTOR W.                                        MA30A.87
      DO 30 JJ=ISTART,IFIN
      J=ICN(JJ)
   30 W(J)=A(JJ)
C                                                                       MA30A.87
C ADD MULTIPLES OF APPROPRIATE ROWS OF  I TO I-1  TO ROW I.             MA30A.87
      DO 50 JJ=ISTART,ILEND
      J=ICN(JJ)
C IPIVJ IS POSITION OF PIVOT IN ROW J.                                  MA30A.87
      IPIVJ=IW(J)+LENRL(J)
C FORM MULTIPLIER AU.                                                   MA30A.88
      AU=-W(J)/A(IPIVJ)
      W(J)=AU
C AU * ROW J (U PART) IS ADDED TO ROW I.                                MA30A.88
      IPIVJ=IPIVJ+1
      JFIN=IW(J)+LENR(J)-1
      IF (IPIVJ.GT.JFIN) GO TO 50
C INNERMOST LOOP.                                                       MA30A.88
      DO 40 JAYJAY=IPIVJ,JFIN
      JAY=ICN(JAYJAY)
   40 W(JAY)=W(JAY)+AU*A(JAYJAY)
C                                                                       MA30A.89
   50 CONTINUE
C RELOAD W BACK INTO A (NOW L/U)                                        MA30A.89
      DO 60 JJ=ISTART,IFIN
      J=ICN(JJ)
      A(JJ)=W(J)
   60 W(J)=ZERO
C WE NOW PERFORM THE STABILITY CHECKS.                                  MA30A.89
   70 PIVPOS=ILEND+1
      IF (IQ(I).GT.0) GO TO 120
C MATRIX HAD SINGULARITY AT THIS POINT IN MA30A/AD.                     MA30A.90
C IS IT THE FIRST SUCH PIVOT IN CURRENT BLOCK '                         MA30A.90
      IF (ISING.EQ.0) ISING=I
C DOES CURRENT MATRIX HAVE A SINGULARITY IN THE SAME PLACE '            MA30A.90
      IF (PIVPOS.GT.IFIN) GO TO 80
      IF (A(PIVPOS).NE.ZERO) GO TO 150
C IT DOES .. SO SET ISING IF IT IS NOT THE END OF THE CURRENT BLOCK     MA30A.90
C CHECK TO SEE THAT APPROPRIATE PART OF L/U IS ZERO OR NULL.            MA30A.90
   80 IF (ISTART.GT.IFIN) GO TO 100
      DO 90 JJ=ISTART,IFIN
      IF (ICN(JJ).LT.ISING) GO TO 90
      IF (A(JJ).NE.ZERO) GO TO 150
   90 CONTINUE
  100 IF (PIVPOS.LE.IFIN) A(PIVPOS)=ONE
      IF (IP(I).GT.0.AND.I.NE.N) GO TO 140
C END OF CURRENT BLOCK ... RESET ZERO PIVOTS AND ISING.                 MA30A.91
      DO 110 J=ISING,I
      IF ((LENR(J)-LENRL(J)).EQ.0) GO TO 110
      JJ=IW(J)+LENRL(J)
      A(JJ)=ZERO
  110 CONTINUE
      ISING=0
      GO TO 140
C MATRIX HAD NON-ZERO PIVOT IN MA30A/AD AT THIS STAGE.                  MA30A.92
  120 IF (PIVPOS.GT.IFIN) GO TO 150
      IF (A(PIVPOS).EQ.ZERO) GO TO 150
      IF (.NOT.STAB) GO TO 140
      ROWMAX=ZERO
      DO 130 JJ=PIVPOS,IFIN
C 130 ROWMAX=DMAX1(ROWMAX,DABS(A(JJ)))                               JD/MA30A.93
  130 ROWMAX=AMAX1(ROWMAX,ABS(A(JJ)))
C     IF (DABS(A(PIVPOS))/ROWMAX.GE.RMIN) GO TO 140                  JD/MA30A.93
      IF (ABS(A(PIVPOS))/ROWMAX.GE.RMIN) GO TO 140
      IFLAG=I
C     RMIN=DABS(A(PIVPOS))/ROWMAX                                    JD/MA30A.93
C   ****    END OF MAIN LOOP    ****                                    MA30A.93
      RMIN=ABS(A(PIVPOS))/ROWMAX
  140 CONTINUE
C                                                                       MA30A.93
      GO TO 170
C   ***   ERROR RETURN   ***                                            MA30A.94
  150 IF (LP.NE.0) WRITE(LP,160) I
  160 FORMAT(55H ERROR RETURN FROM MA30B/BD SINGULARITY DETECTED IN ROW,
     AI8)
      IFLAG=-I
C                                                                       MA30A.94
  170 RETURN
      END
      SUBROUTINE MA30C(N,ICN,A,LICN,LENR,LENRL,LENOFF,IDISP,IP,IQ,      MA30A.95
C     SUBROUTINE MA30CD(N,ICN,A,LICN,LENR,LENRL,LENOFF,IDISP,IP,IQ,  JD/MA30A.94
C    1X,W,MTYPE)                                                     JD/MA30A.95
     1X,W,MTYPE)
C     DOUBLE PRECISION A(LICN),X(N),W(N),WII,WI,RESID,ZERO           JD/MA30A.95
      REAL A(LICN),X(N),W(N)
      INTEGER IDISP(2)
      LOGICAL NEG,NOBLOC
      INTEGER ICN(LICN),LENR(N),LENRL(N),LENOFF(N),IP(N),IQ(N)
C     COMMON /MA30HD/ RESID                                          JD/MA30A.95
      COMMON /MA30H/ RESID
C     DATA ZERO/0.0D0/                                               JD/MA30A.96
C THE FINAL VALUE OF RESID IS THE MAXIMUM RESIDUAL FOR AN INCONSISTENT  MA30A.96
C     SET OF EQUATIONS.                                                 MA30A.96
      DATA ZERO/0.0/
      RESID=ZERO
C NOBLOC IS .TRUE. IF SUBROUTINE BLOCK HAS BEEN USED PREVIOUSLY AND     MA30A.96
C     IS .FALSE. OTHERWISE.  THE VALUE .FALSE. MEANS THAT LENOFF        MA30A.96
C     WILL NOT BE SUBSEQUENTLY ACCESSED.                                MA30A.96
      NOBLOC=LENOFF(1).LT.0
      IF (MTYPE.NE.1) GO TO 140
C                                                                       MA30A.97
C WE NOW SOLVE   A * X = B.                                             MA30A.97
C NEG IS USED TO INDICATE WHEN THE LAST ROW IN A BLOCK HAS BEEN         MA30A.97
C     REACHED.  IT IS THEN SET TO TRUE WHEREAFTER BACKSUBSTITUTION IS   MA30A.97
C     PERFORMED ON THE BLOCK.                                           MA30A.97
      NEG=.FALSE.
C IP(N) IS NEGATED SO THAT THE LAST ROW OF THE LAST BLOCK CAN BE        MA30A.97
C     RECOGNISED.  IT IS RESET TO ITS POSITIVE VALUE ON EXIT.           MA30A.97
      IP(N)=-IP(N)
C PREORDER VECTOR ... W(I) = X(IP(I))                                   MA30A.98
      DO 10 II=1,N
      I=IP(II)
      I=IABS(I)
   10 W(II)=X(I)
C LT HOLDS THE POSITION OF THE FIRST NON-ZERO IN THE CURRENT ROW OF THE MA30A.98
C     OFF-DIAGONAL BLOCKS.                                              MA30A.98
      LT=1
C IFIRST HOLDS THE INDEX OF THE FIRST ROW IN THE CURRENT BLOCK.         MA30A.98
      IFIRST=1
C IBLOCK HOLDS THE POSITION OF THE FIRST NON-ZERO IN THE CURRENT ROW    MA30A.99
C     OF THE LU DECOMPOSITION OF THE DIAGONAL BLOCKS.                   MA30A.99
      IBLOCK=IDISP(1)
C IF I IS NOT THE LAST ROW OF A BLOCK, THEN A PASS THROUGH THIS LOOP    MA30A.99
C     ADDS THE INNER PRODUCT OF ROW I OF THE OFF-DIAGONAL BLOCKS AND W  MA30A.99
C     TO W AND PERFORMS FORWARD ELIMINATION USING ROW I OF THE LU       MA30A.99
C     DECOMPOSITION.   IF I IS THE LAST ROW OF A BLOCK THEN, AFTER      MA30A.99
C     PERFORMING THESE AFOREMENTIONED OPERATIONS, BACKSUBSTITUTION IS   MA30A.99
C     PERFORMED USING THE ROWS OF THE BLOCK.                            MA30A.99
      DO 120 I=1,N
      WI=W(I)
      IF(NOBLOC)GO TO 30
      IF (LENOFF(I).EQ.0) GO TO 30
C OPERATIONS USING LOWER TRIANGULAR BLOCKS.                             MA30A.10
C LTEND IS THE END OF ROW I IN THE OFF-DIAGONAL BLOCKS.                 MA30A.10
      LTEND=LT+LENOFF(I)-1
      DO 20 JJ=LT,LTEND
      J=ICN(JJ)
   20 WI=WI-A(JJ)*W(J)
C LT IS SET THE BEGINNING OF THE NEXT OFF-DIAGONAL ROW.                 MA30A.10
      LT=LTEND+1
C SET NEG TO .TRUE. IF WE ARE ON THE LAST ROW OF THE BLOCK.             MA30A.10
   30 IF (IP(I).LT.0) NEG=.TRUE.
      IF (LENRL(I).EQ.0) GO TO 50
C FORWARD ELIMINATION PHASE.                                            MA30A.10
C IEND IS THE END OF THE L PART OF ROW I IN THE LU DECOMPOSITION.       MA30A.10
      IEND=IBLOCK+LENRL(I)-1
      DO 40 JJ=IBLOCK,IEND
      J=ICN(JJ)
   40 WI=WI+A(JJ)*W(J)
C IBLOCK IS ADJUSTED TO POINT TO THE START OF THE NEXT ROW.             MA30A.10
   50 IBLOCK=IBLOCK+LENR(I)
      W(I)=WI
      IF (.NOT.NEG) GO TO 120
C BACK SUBSTITUTION PHASE.                                              MA30A.10
C J1 IS POSITION IN A/ICN AFTER END OF BLOCK BEGINNING IN ROW IFIRST    MA30A.10
C     AND ENDING IN ROW I.                                              MA30A.10
      J1=IBLOCK
C ARE THERE ANY SINGULARITIES IN THIS BLOCK'  IF NOT, CONTINUE WITH     MA30A.10
C     THE BACKSUBSTITUTION.                                             MA30A.10
      IB=I
      IF (IQ(I).GT.0) GO TO 70
      DO 60 III=IFIRST,I
      IB=I-III+IFIRST
      IF (IQ(IB).GT.0) GO TO 70
      J1=J1-LENR(IB)
C     RESID=DMAX1(RESID,DABS(W(IB)))                                 JD/MA30A.10
      RESID=AMAX1(RESID,ABS(W(IB)))
      W(IB)=ZERO
   60 CONTINUE
C ENTIRE BLOCK IS SINGULAR.                                             MA30A.10
      GO TO 110
C EACH PASS THROUGH THIS LOOP PERFORMS THE BACK-SUBSTITUTION            MA30A.10
C     OPERATIONS FOR A SINGLE ROW, STARTING AT THE END OF THE BLOCK AND MA30A.10
C     WORKING THROUGH IT IN REVERSE ORDER.                              MA30A.10
   70 DO 100 III=IFIRST,IB
      II=IB-III+IFIRST
C J2 IS END OF ROW II.                                                  MA30A.10
      J2=J1-1
C J1 IS BEGINNING OF ROW II.                                            MA30A.10
      J1=J1-LENR(II)
C JPIV IS THE POSITION OF THE PIVOT IN ROW II.                          MA30A.10
      JPIV=J1+LENRL(II)
      JPIVP1=JPIV+1
C IF ROW  II OF U HAS NO NON-ZEROS GO TO 90.                            MA30A.10
      IF (J2.LT.JPIVP1) GO TO 90
      WII=W(II)
      DO 80 JJ=JPIVP1,J2
      J=ICN(JJ)
   80 WII=WII-A(JJ)*W(J)
      W(II)=WII
   90 W(II)=W(II)/A(JPIV)
  100 CONTINUE
  110 IFIRST=I+1
      NEG=.FALSE.
  120 CONTINUE
C                                                                       MA30A.10
C REORDER SOLUTION VECTOR ... X(I) = W(IQINVERSE(I))                    MA30A.10
      DO 130 II=1,N
      I=IQ(II)
      I=IABS(I)
  130 X(I)=W(II)
      IP(N)=-IP(N)
      GO TO 310
C                                                                       MA30A.10
C                                                                       MA30A.10
C WE NOW SOLVE   ATRANSPOSE * X = B.                                    MA30A.10
C PREORDER VECTOR ... W(I)=X(IQ(I))                                     MA30A.10
  140 DO 150 II=1,N
      I=IQ(II)
      I=IABS(I)
  150 W(II)=X(I)
C LJ1 POINTS TO THE BEGINNING THE CURRENT ROW IN THE OFF-DIAGONAL       MA30A.10
C     BLOCKS.                                                           MA30A.10
      LJ1=IDISP(1)
C IBLOCK IS INITIALIZED TO POINT TO THE BEGINNING OF THE BLOCK AFTER    MA30A.10
C     THE LAST ONE !                                                    MA30A.10
      IBLOCK=IDISP(2)+1
C ILAST IS THE LAST ROW IN THE CURRENT BLOCK.                           MA30A.10
      ILAST=N
C IBLEND POINTS TO THE POSITION AFTER THE LAST NON-ZERO IN THE          MA30A.10
C     CURRENT BLOCK.                                                    MA30A.10
      IBLEND=IBLOCK
C EACH PASS THROUGH THIS LOOP OPERATES WITH ONE DIAGONAL BLOCK AND      MA30A.10
C     THE OFF-DIAGONAL PART OF THE MATRIX CORRESPONDING TO THE ROWS     MA30A.10
C     OF THIS BLOCK.  THE BLOCKS ARE TAKEN IN REVERSE ORDER AND THE     MA30A.10
C     NUMBER OF TIMES THE LOOP IS ENTERED IS MIN(N,NO. BLOCKS+1).       MA30A.10
      DO 280 NUMBLK=1,N
      IF (ILAST.EQ.0) GO TO 290
      IBLOCK=IBLOCK-LENR(ILAST)
C THIS LOOP FINDS THE INDEX OF THE FIRST ROW IN THE CURRENT BLOCK..     MA30A.11
C     IT IS FIRST AND IBLOCK IS SET TO THE POSITION OF THE BEGINNING    MA30A.11
C     OF THIS FIRST ROW.                                                MA30A.11
      DO 160 K=1,N
      II=ILAST-K
      IF (II.EQ.0) GO TO 170
      IF (IP(II).LT.0) GO TO 170
      IBLOCK=IBLOCK-LENR(II)
  160 CONTINUE
  170 IFIRST=II+1
C J1 POINTS TO THE POSITION OF THE BEGINNING OF ROW I (LT PART) OR PIVOTMA30A.11
      J1=IBLOCK
C FORWARD ELIMINATION.                                                  MA30A.11
C EACH PASS THROUGH THIS LOOP PERFORMS THE OPERATIONS FOR ONE ROW OF THEMA30A.11
C     BLOCK.  IF THE CORRESPONDING ELEMENT OF W IS ZERO THEN THE        MA30A.11
C     OPERATIONS CAN BE AVOIDED.                                        MA30A.11
      DO 200 I=IFIRST,ILAST
      IF (W(I).EQ.ZERO) GO TO 195
C IS ROW I SINGULAR'  IF SO, GO TO 210                                  MA30A.11
      IF (IQ(I).LT.0) GO TO 210
C J2 FIRST POINTS TO THE PIVOT IN ROW I AND THEN IS MADE TO POINT TO THEMA30A.11
C     FIRST NON-ZERO IN THE U TRANSPOSE PART OF THE ROW.                MA30A.11
      J2=J1+LENRL(I)
      WI=W(I)/A(J2)
      IF (LENR(I)-LENRL(I).EQ.1) GO TO 190
      J2=J2+1
C J3 POINTS TO THE END OF ROW I.                                        MA30A.11
      J3=J1+LENR(I)-1
      DO 180 JJ=J2,J3
      J=ICN(JJ)
  180 W(J)=W(J)-A(JJ)*WI
  190 W(I)=WI
  195 J1=J1+LENR(I)
  200 CONTINUE
      GO TO 230
C DEALS WITH REST OF BLOCK WHICH IS SINGULAR.                           MA30A.11
  210 DO 220 II=I,ILAST
C     RESID=DMAX1(RESID,DABS(W(II)))                                 JD/MA30A.11
      RESID=AMAX1(RESID,ABS(W(II)))
      W(II)=ZERO
  220 CONTINUE
C BACK SUBSTITUTION.                                                    MA30A.11
C THIS LOOP DOES THE BACK SUBSTITUTION ON THE ROWS OF THE BLOCK IN      MA30A.11
C     THE REVERSE ORDER DOING IT SIMULTANEOUSLY ON THE L TRANSPOSE PART MA30A.11
C     OF THE DIAGONAL BLOCKS AND THE OFF-DIAGONAL BLOCKS.               MA30A.11
  230 J1=IBLEND
      DO 270 IBACK=IFIRST,ILAST
      I=ILAST-IBACK+IFIRST
C J1 POINTS TO THE BEGINNING OF ROW I.                                  MA30A.11
      J1=J1-LENR(I)
      IF (LENRL(I).EQ.0) GO TO 250
C J2 POINTS TO THE END OF THE L TRANSPOSE PART OF ROW I.                MA30A.11
      J2=J1+LENRL(I)-1
      DO 240 JJ=J1,J2
      J=ICN(JJ)
  240 W(J)=W(J)+A(JJ)*W(I)
  250 IF(NOBLOC)GO TO 270
C OPERATIONS USING LOWER TRIANGULAR BLOCKS.                             MA30A.11
      IF(LENOFF(I).EQ.0)GO TO 270
C LJ2 POINTS TO THE END OF ROW I OF THE OFF-DIAGONAL BLOCKS.            MA30A.11
      LJ2=LJ1-1
C LJ1 POINTS TO THE BEGINNING OF ROW I OF THE OFF-DIAGONAL BLOCKS.      MA30A.11
      LJ1=LJ1-LENOFF(I)
      DO 260 JJ=LJ1,LJ2
      J=ICN(JJ)
  260 W(J)=W(J)-A(JJ)*W(I)
  270 CONTINUE
      IBLEND=J1
      ILAST=IFIRST-1
  280 CONTINUE
C REORDER SOLUTION VECTOR ... X(I)=W(IPINVERSE(I))                      MA30A.11
  290 DO 300 II=1,N
      I=IP(II)
      I=IABS(I)
  300 X(I)=W(II)
C                                                                       MA30A.11
  310 RETURN
      END
      SUBROUTINE MA28A(N,NZ,A,LICN,IRN,LIRN,ICN,U,IKEEP,                MA28A.57
C I AND J ARE IBM SINGLE AND DOUBLE PRECISION CODES RESP.  IJSD/        MA28A.3
C S AND D ARE STANDARD SINGLE AND DOUBLE PRECISION CODES RESP.          MA28A.4
C     SUBROUTINE MA28AD(N,NZ,A,LICN,IRN,LIRN,ICN,U,IKEEP,            JD/MA28A.5
C    1IW,W,IFLAG)                                                    JD/MA28A.6
C THE PARAMETERS ARE AS FOLLOWS.....                                    MA28A.7
C N     INTEGER  ORDER OF MATRIX  NOT ALTERED BY SUBROUTINE.            MA28A.8
C NZ    INTEGER  NUMBER OF NON-ZEROS IN INPUT MATRIX  NOT ALTERED       MA28A.9
C     BY SUBROUTINE.                                                    MA28A.10
C A     REAL/DOUBLE PRECISION ARRAY  LENGTH LICN.  HOLDS NON-ZEROS OF   MA28A.11
C     MATRIX ON ENTRY AND NON-ZEROS OF FACTORS ON EXIT.  REORDERED BY   MA28A.12
C     MC20A/AD AND MC23A/AD AND ALTERED BY MA30A/AD.                    MA28A.13
C LICN  INTEGER  LENGTH OF ARRAYS A AND ICN.  NOT ALTERED BY            MA28A.14
C     SUBROUTINE.                                                       MA28A.15
C IRN   INTEGER*2 ARRAY  LENGTH LIRN.  HOLDS ROW INDICES ON INPUT ...   MA28A.16
C     USED AS WORKSPACE BY MA30A/AD TO HOLD COLUMN ORIENTATION OF       MA28A.17
C     MATRIX.                                                           MA28A.18
C LIRN  INTEGER  LENGTH OF ARRAY IRN.                                   MA28A.19
C ICN   INTEGER*2 ARRAY  LENGTH LICN.  HOLDS COLUMN INDICES ON ENTRY    MA28A.20
C     AND COLUMN INDICES OF DECOMPOSED MATRIX ON EXIT. REORDERED BY     MA28A.21
C     MC20A/AD AND MC23A/AD AND ALTERED BY MA30A/AD.                    MA28A.22
C U     REAL/DOUBLE PRECISION VARIABLE  SET BY USER TO CONTROL          MA28A.23
C     BIAS TOWARDS NUMERIC OR SPARSITY PIVOTING.  U=1.0 GIVES PARTIAL   MA28A.24
C     PIVOTING WHILE U=0. DOES NOT CHECK MULTIPLIERS AT ALL.            MA28A.25
C     VALUES OF U GREATER THAN ONE ARE TREATED AS ONE WHILE NEGATIVE    MA28A.26
C     VALUES ARE TREATED AS ZERO.  NOT ALTERED BY SUBROUTINE.           MA28A.27
C IKEEP  INTEGER*2 ARRAY  LENGTH 5*N  USED AS WORKSPACE BY MA28A/AD     MA28A.28
C     (SEE LATER COMMENTS).  IT IS NOT REQUIRED TO BE SET ON ENTRY      MA28A.29
C     AND, ON EXIT, IT CONTAINS INFORMATION ABOUT THE DECOMPOSITION.    MA28A.30
C     IT SHOULD BE PRESERVED BETWEEN THIS CALL AND SUBSEQUENT CALLS     MA28A.31
C     TO MA28B/BD OR MA28C/CD.                                          MA28A.32
C     IKEEP(I,1),I=1,N  HOLDS THE TOTAL LENGTH OF THE PART OF ROW I     MA28A.33
C     IN THE DIAGONAL BLOCK.                                            MA28A.34
C     ROW IKEEP(I,2),I=1,N  OF THE INPUT MATRIX IS THE ITH ROW IN       MA28A.35
C     PIVOT ORDER.                                                      MA28A.36
C     COLUMN IKEEP(I,3),I=1,N  OF THE INPUT MATRIX IS THE ITH COLUMN    MA28A.37
C     IN PIVOT ORDER.                                                   MA28A.38
C     IKEEP(I,4),I=1,N  HOLDS THE LENGTH OF THE PART OF ROW I IN        MA28A.39
C     THE L PART OF THE L/U DECOMPOSITION.                              MA28A.40
C     IKEEP(I,5),I=1,N  HOLDS THE LENGTH OF THE PART OF ROW I IN THE    MA28A.41
C     OFF-DIAGONAL BLOCKS.  IF THERE IS ONLY ONE DIAGONAL BLOCK,        MA28A.42
C     IKEEP(1,5) WILL BE SET TO -1.                                     MA28A.43
C IW    INTEGER*2 ARRAY  LENGTH 10*N.  TO OBTAIN CORRECT ALIGNMENT      MA28A.44
C     FOR THIS ARRAY, BECAUSE PARTS OF IT ARE USED AS INTEGER*4         MA28A.45
C     WORKSPACE, THE USER SHOULD HAVE DECLARED IT TO BE AN              MA28A.46
C     INTEGER ARRAY OF LENGTH 5*N.  IN THE STANDARD VERSION THIS        MA28A.47
C     DISTINCTION DISAPPEARS AND THE LENGTH OF THIS WORK-ARRAY (IN      MA28A.48
C     THE USER[S PROGRAM) SHOULD CONSEQUENTLY BE CHANGED TO 8*N.        MA28A.49
C W     REAL/DOUBLE PRECISION ARRAY  LENGTH N.  USED BY MC24A/AD BOTH   MA28A.50
C     AS WORKSPACE AND TO RETURN GROWTH ESTIMATE IN W(1).  THE USE OF   MA28A.51
C     THIS ARRAY BY MA28A/AD IS THUS OPTIONAL DEPENDING ON COMMON       MA28A.52
C     BLOCK LOGICAL VARIABLE GROW.                                      MA28A.53
C IFLAG  INTEGER VARIABLE  USED AS ERROR FLAG BY ROUTINE.  A POSITIVE   MA28A.54
C     OR ZERO VALUE ON EXIT INDICATES SUCCESS.  POSSIBLE NEGATIVE       MA28A.55
C     VALUES ARE -1 THROUGH -14.                                        MA28A.56
     1IW,W,IFLAG)
C     DOUBLE PRECISION A(LICN),U,W(N),UPRIV,RMIN,EPS,RESID,ZERO,     JD/MA28A.59
C    1THEMAX                                                         JD/MA28A.60
      REAL A(LICN),W(N)
      INTEGER IDISP(2),IPRIV4
      INTEGER ICN(LICN),IRN(LIRN),IKEEP(N,5),IW(N,8),IPRIV2(2)
      LOGICAL GROW,LBLOCK,ABORT,ABORT1,ABORT2,ABORT3,ABORTA,ABORTB
C COMMON BLOCKS ... COMMON BLOCK MA28F/FD IS USED MERELY                MA28A.66
C     TO COMMUNICATE WITH COMMON BLOCK MA30F/FD  SO THAT THE USER       MA28A.67
C     NEED NOT DECLARE THIS COMMON BLOCK IN HIS MAIN PROGRAM.           MA28A.68
C THE COMMON BLOCK VARIABLES ARE AS FOLLOWS ...                         MA28A.69
C LP,MP  INTEGER  DEFAULT VALUE 6 (LINE PRINTER).  UNIT NUMBER          MA28A.70
C     FOR ERROR MESSAGES AND DUPLICATE ELEMENT WARNING RESP.            MA28A.71
C NLP,MLP  INTEGER  UNIT NUMBER FOR MESSAGES FROM MA30A/AD AND          MA28A.72
C     MC23A/AD RESP.  SET BY MA28A/AD TO VALUE OF LP.                   MA28A.73
C LBLOCK  LOGICAL  DEFAULT VALUE TRUE.  IF TRUE MC23A/AD IS USED        MA28A.74
C     TO FIRST PERMUTE THE MATRIX TO BLOCK LOWER TRIANGULAR FORM.       MA28A.75
C GROW    LOGICAL  DEFAULT VALUE TRUE.  IF TRUE THEN AN ESTIMATE        MA28A.76
C     OF THE INCREASE IN SIZE OF MATRIX ELEMENTS DURING L/U             MA28A.77
C     DECOMPOSITION IS GIVEN BY MC24A/AD.                               MA28A.78
C EPS,RMIN,RESID  REAL/DOUBLE PRECISION VARIABLES NOT REFERENCED        MA28A.79
C     BY MA28A/AD.                                                      MA28A.80
C IRNCP,ICNCP  INTEGER  SET TO NUMBER OF COMPRESSES ON ARRAYS IRN AND   MA28A.81
C     ICN/A RESPECTIVELY.                                               MA28A.82
C MINIRN,MINICN  INTEGER  MINIMUM LENGTH OF ARRAYS IRN AND ICN/A        MA28A.83
C     RESPECTIVELY, FOR SUCCESS ON FUTURE RUNS.                         MA28A.84
C IRANK  INTEGER   ESTIMATED RANK OF MATRIX.                            MA28A.85
C MIRNCP,MICNCP,MIRANK,MIRN,MICN INTEGER VARIABLES.  USED TO            MA28A.86
C     COMMUNICATE BETWEEN MA30F/FD AND MA28F/FD VALUES OF ABOVENAMED    MA28A.87
C     VARIABLES WITH SOMEWHAT SIMILAR NAMES.                            MA28A.88
C ABORT1,ABORT2  LOGICAL VARIABLES WITH DEFAULT VALUE TRUE.  IF FALSE   MA28A.89
C     THEN DECOMPOSITION WILL BE PERFORMED EVEN IF THE MATRIX IS        MA28A.90
C     STRUCTURALLY OR NUMERICALLY SINGULAR RESPECTIVELY.                MA28A.91
C ABORTA,ABORTB  LOGICAL VARIABLES USED TO COMMUNICATE VALUES OF        MA28A.92
C     ABORT1 AND ABORT2 TO MA30A/AD.                                    MA28A.93
C ABORT  LOGICAL  USED TO COMMUNICATE VALUE OF ABORT1 TO MC23A/AD.      MA28A.94
C ABORT3  LOGICAL VARIABLE NOT REFERENCED BY MA28A/AD.                  MA28A.95
C IDISP   INTEGER ARRAY  LENGTH 2.  USED TO COMMUNICATE INFORMATION     MA28A.96
C     ON DECOMPOSITION BETWEEN THIS CALL TO MA28A/AD AND SUBSEQUENT     MA28A.97
C     CALLS TO MA28B/BD AND MA28C/CD.  ON EXIT, IDISP(1) AND            MA28A.98
C     IDISP(2) INDICATE POSITION IN ARRAYS A AND ICN OF THE             MA28A.99
C     FIRST AND LAST ELEMENTS IN THE L/U DECOMPOSITION OF THE           MA28A.10
C     DIAGONAL BLOCKS, RESPECTIVELY.                                    MA28A.10
C NUMNZ  INTEGER  STRUCTURAL RANK OF MATRIX.                            MA28A.10
C NUM    INTEGER  NUMBER OF DIAGONAL BLOCKS.                            MA28A.10
C LARGE  INTEGER  SIZE OF LARGEST DIAGONAL BLOCK.                       MA28A.10
C     INTERNAL VARIABLES AND WORKSPACE USED IN  MA28A/AD ARE DEFINED    MA28A.10
C     WITHIN THE SUBROUTINE IMMEDIATELY PRIOR TO THEIR FIRST USE.       MA28A.10
C     COMMON /MA28ED/ LP,MP,LBLOCK,GROW                              JD/MA28A.10
      COMMON /MA28E/ LP,MP,LBLOCK,GROW
C     COMMON /MA28FD/ EPS,RMIN,RESID,IRNCP,ICNCP,MINIRN,MINICN,      JD/MA28A.10
C    1IRANK,ABORT1,ABORT2                                            JD/MA28A.11
      COMMON /MA28F/ EPS,RMIN,RESID,IRNCP,ICNCP,MINIRN,MINICN,
     AIRANK,ABORT1,ABORT2
C     COMMON /MA28GD/ IDISP                                          JD/MA28A.11
      COMMON /MA28G/ IDISP
C     COMMON /MA30ED/ NLP,ABORTA,ABORTB,ABORT3                       JD/MA28A.11
      COMMON /MA30E/ NLP,ABORTA,ABORTB,ABORT3
C     COMMON /MA30FD/ MIRNCP,MICNCP,MIRANK,MIRN,MICN                 JD/MA28A.11
      COMMON /MA30F/ MIRNCP,MICNCP,MIRANK,MIRN,MICN
C     COMMON /MC23BD/ MLP,NUMNZ,NUM,LARGE,ABORT                      JD/MA28A.11
C EQUIVALENCE IS USED TO OBTAIN INTEGER*4 INFORMATION FROM INTEGER*2    MA28A.12
C     ARRAYS  ...  SEE LATER COMMENTS ON THE SETTING OF IPRIV4.         MA28A.12
      COMMON /MC23B/ MLP,NUMNZ,NUM,LARGE,ABORT
      EQUIVALENCE(IPRIV4,IPRIV2(1))
C     DATA ZERO /0.0D0/                                              JD/MA28A.12
C SOME  INITIALIZATION AND TRANSFER OF INFORMATION BETWEEN              MA28A.12
C     COMMON BLOCKS (SEE EARLIER COMMENTS).                             MA28A.12
      DATA ZERO /0.0E0/
      IFLAG=0
      ABORTA=ABORT1
      ABORTB=ABORT2
      ABORT=ABORT1
      MLP=LP
      NLP=LP
C UPRIV PRIVATE COPY OF U IS USED IN CASE IT IS OUTSIDE                 MA28A.13
C     RANGE  ZERO TO ONE  AND  IS THUS ALTERED BY MA30A/AD.             MA28A.13
      UPRIV=U
C SIMPLE DATA CHECK ON INPUT VARIABLES AND ARRAY DIMENSIONS.            MA28A.13
C     IF (N.GT.0) GO TO 2  SD/                                          MA28A.13
      IF (N.GT.0.AND.N.LE.32767) GO TO 2
      IFLAG=-8
      IF (LP.NE.0) WRITE(LP,1) N
 1    FORMAT(36X,17HN OUT OF RANGE = ,I10)
      GO TO 999
 2    IF (NZ.GT.0) GO TO 4
      IFLAG=-9
      IF (LP.NE.0) WRITE(LP,3) NZ
 3    FORMAT(36X,18HNZ NON POSITIVE = ,I10)
      GO TO 999
 4    IF (LICN.GE.NZ) GO TO 6
      IFLAG=-10
      IF (LP.NE.0) WRITE(LP,5) LICN
 5    FORMAT(36X,17HLICN TOO SMALL = ,I10)
      GO TO 999
 6    IF (LIRN.GE.NZ) GO TO 8
      IFLAG=-11
      IF (LP.NE.0) WRITE(LP,7) LIRN
 7    FORMAT(36X,17HLIRN TOO SMALL = ,I10)
      GO TO 999
C                                                                       MA28A.15
C DATA CHECK TO SEE IF ALL INDICES LIE BETWEEN 1 AND N.                 MA28A.16
 8    DO 30 I=1,NZ
      IF (IRN(I).GT.0.AND.IRN(I).LE.N.AND.ICN(I).GT.0.AND.ICN(I).LE.N)
     AGO TO 30
      IF (IFLAG.EQ.0.AND.LP.NE.0) WRITE(LP,10)
 10   FORMAT(62H ERROR RETURN FROM MA28A/AD BECAUSE INDICES FOUND OUT OF
     A RANGE)
      IFLAG=-12
      IF (LP.NE.0) WRITE(LP,20) I,A(I),IRN(I),ICN(I)
20    FORMAT(1X,I6,22HTH ELEMENT WITH VALUE ,E22.14,30H IS OUT OF RANGE
     AWITH INDICES ,I8,2H ,,I8)
 30   CONTINUE
      IF (IFLAG.LT.0) GO TO 1000
C                                                                       MA28A.17
C SORT ELEMENTS INTO ROW ORDER.                                         MA28A.17
C     CALL MC20AD(N,NZ,A,ICN,IW,IRN,0)                               JD/MA28A.17
C                                                                       MA28A.17
C THESE TWO STATEMENTS (TOGETHER WITH THE EARLIER EQUIVALENCE STATEMENT)MA28A.17
C SET IPRIV4 EQUAL TO THE INTEGER*4 VALUE CONSISTING OF THE             MA28A.17
C CONCATENATION OF THE TWO INTEGER*2 WORDS IW(1,1) AND IW(2,1).         MA28A.17
C THIS IS NECESSARY IN THE IBM VERSION BECAUSE MC20A/AD EXPECTS AN      MA28A.18
C INTEGER*4 ARGUMENT IN IW.  THE STATEMENTS CAN BE LEFT IN              MA28A.18
C WITHOUT AFFECTING A STANDARD FORTRAN VERSION (ASSUMING THE            MA28A.18
C EQUIVALENCE STATEMENT IS KEPT).                                       MA28A.18
      CALL MC20A(N,NZ,A,ICN,IW,IRN,0)
      IPRIV2(1)=IW(1,1)
      IPRIV2(2)=IW(1,2)
      IF (N.GT.1) IPRIV2(2)=IW(2,1)
C PART OF IKEEP IS USED HERE AS A WORK-ARRAY.  IKEEP(I,2) IS            MA28A.18
C     THE LAST ROW TO HAVE A NON-ZERO IN COLUMN I.  IKEEP(I,3)          MA28A.18
C     IS THE OFF-SET OF COLUMN I FROM THE START OF THE ROW.             MA28A.19
      DO 40 I=1,N
      IKEEP(I,2)=0
 40   IKEEP(I,1)=0
C                                                                       MA28A.19
C CHECK FOR DUPLICATE ELEMENTS .. SUMMING ANY SUCH ENTRIES AND          MA28A.19
C     PRINTING A WARNING MESSAGE ON UNIT MP.                            MA28A.19
C MOVE IS EQUAL TO THE NUMBER OF DUPLICATE ELEMENTS FOUND.              MA28A.19
      MOVE=0
C THE LOOP ALSO CALCULATES THE LARGEST ELEMENT IN THE MATRIX, THEMAX.   MA28A.19
      THEMAX=ZERO
C J1 IS POSITION IN ARRAYS OF FIRST NON-ZERO IN ROW.                    MA28A.20
      J1=IPRIV4
      DO 80 I=1,N
      IF (I.NE.N) GO TO 45
      IPRIV4=NZ+1
      GO TO 49
C THESE STATEMENTS ARE USED AS ABOVE TO SET IPRIV4.                     MA28A.20
C THIS TIME THE CHANGE INDICATED BY THE SPECIAL COMMENT CARD IS         MA28A.20
C REQUIRED FOR SUCCESSFUL OPERATION OF THE STANDARD VERSION.            MA28A.20
 45   DO 47 L=1,2
      K=1
C     J=I+1        SD/                                                  MA28A.21
      J=I+1
      IF (J.LE.N) GO TO 46
      J=J-N
      K=2
 46   IPRIV2(L)=IW(J,K)
 47   CONTINUE
 49   LENGTH=IPRIV4-J1
      IF (LENGTH.EQ.0) GO TO 80
      J2=IPRIV4-1
      NEWJ1=J1-MOVE
      DO 70 JJ=J1,J2
      J=ICN(JJ)
C     THEMAX=DMAX1(THEMAX,DABS(A(JJ)))                               JD/MA28A.22
      THEMAX=AMAX1(THEMAX,ABS(A(JJ)))
      IF (IKEEP(J,2).EQ.I) GO TO 50
C FIRST TIME COLUMN HAS OCURRED IN CURRENT ROW.                         MA28A.22
      IKEEP(J,2)=I
      IKEEP(J,3)=JJ-MOVE-NEWJ1
      IF (MOVE.EQ.0) GO TO 70
C SHIFT NECESSARY BECAUSE OF  PREVIOUS DUPLICATE ELEMENT.               MA28A.23
      NEWPOS=JJ-MOVE
      A(NEWPOS)=A(JJ)
      ICN(NEWPOS)=ICN(JJ)
      GO TO 70
C DUPLICATE ELEMENT.                                                    MA28A.23
 50   MOVE=MOVE+1
      LENGTH=LENGTH-1
      JAY=IKEEP(J,3)+NEWJ1
      IF (MP.NE.0) WRITE(MP,60) I,J,A(JJ)
 60   FORMAT(31H DUPLICATE ELEMENT IN POSITION ,I8,2H ,,I8,12H WITH VALU
     AE ,1PE22.14)
      A(JAY)=A(JAY)+A(JJ)
C     THEMAX=DMAX1(THEMAX,DABS(A(JAY)))                              JD/MA28A.24
      THEMAX=AMAX1(THEMAX,ABS(A(JAY)))
 70   CONTINUE
      IKEEP(I,1)=LENGTH
      J1=IPRIV4
 80   CONTINUE
C                                                                       MA28A.25
C IDUP IS ONE IF DUPLICATES EXIST AND IS ZERO OTHERWISE.                MA28A.25
      IDUP=0
      IF (MOVE.NE.0) IDUP=1
C KNUM IS ACTUAL NUMBER OF NON-ZEROS IN MATRIX WITH ANY MULTIPLE        MA28A.25
C     ENTRIES COUNTED ONLY ONCE.                                        MA28A.25
      KNUM=NZ-MOVE
      IF (.NOT.LBLOCK) GO TO 100
      IDISP(1)=KNUM
C                                                                       MA28A.26
C PERFORM BLOCK TRIANGULARISATION.                                      MA28A.26
C     CALL MC23A(N,ICN,A,LICN,IKEEP,IDISP,IKEEP(1,2),IKEEP(1,3), S/     MA28A.26
C    1IKEEP(1,5),IW(1,3),IW)  S/                                        MA28A.26
C     CALL MC23AD(N,ICN,A,LICN,IKEEP,IDISP,IKEEP(1,2),IKEEP(1,3), D/    MA28A.26
C    1IKEEP(1,5),IW(1,3),IW)  D/                                        MA28A.26
C     CALL MC23AD(N,ICN,A,LICN,IKEEP,IDISP,IKEEP(1,2),IKEEP(1,3),     J/MA28A.26
C    1IKEEP(1,5),IW(1,5),IW)                                          J/MA28A.26
      CALL MC23A(N,ICN,A,LICN,IKEEP,IDISP,IKEEP(1,2),IKEEP(1,3),
     AIKEEP(1,5),IW(1,3),IW)
      IF (IDISP(1).GT.0) GO TO 130
      IFLAG=-7
      IF (LP.NE.0) WRITE(LP,90)
 90   FORMAT(36X,26HERROR RETURN FROM MC23A/AD)
      GO TO 999
C                                                                       MA28A.27
C BLOCK TRIANGULARIZATION NOT REQUESTED.                                MA28A.27
C MOVE STRUCTURE TO END OF DATA ARRAYS IN PREPARATION FOR               MA28A.27
C     MA30A/AD.                                                         MA28A.27
C ALSO SET LENOFF(1) TO -1 AND SET PERMUTATION ARRAYS.                  MA28A.27
 100  DO 110 I=1,KNUM
      II=KNUM-I+1
      NEWPOS=LICN-I+1
      ICN(NEWPOS)=ICN(II)
 110  A(NEWPOS)=A(II)
      IDISP(1)=1
      IDISP(2)=LICN-KNUM+1
      DO 120 I=1,N
      IKEEP(I,2)=I
 120  IKEEP(I,3)=I
      IKEEP(1,5)=-1
C                                                                       MA28A.29
C PERFORM L/U DECOMOSITION ON DIAGONAL BLOCKS.                          MA28A.29
C130  CALL MA30A(N,ICN,A,LICN,IKEEP,IKEEP(1,4),IDISP,IKEEP(1,2),  S/    MA28A.29
C    1IKEEP(1,3),IRN,LIRN,IW(1,2),IW(1,3),IW(1,4),IW(1,5),IW(1,6), S/   MA28A.29
C    2IW(1,7),IW(1,8),IW,UPRIV,IFLAG)  S/                               MA28A.29
C130  CALL MA30AD(N,ICN,A,LICN,IKEEP,IKEEP(1,4),IDISP,IKEEP(1,2),  D/   MA28A.29
C    1IKEEP(1,3),IRN,LIRN,IW(1,2),IW(1,3),IW(1,4),IW(1,5),IW(1,6), D/   MA28A.29
C    2IW(1,7),IW(1,8),IW,UPRIV,IFLAG)  D/                               MA28A.29
C130  CALL MA30AD(N,ICN,A,LICN,IKEEP,IKEEP(1,4),IDISP,IKEEP(1,2),     J/MA28A.29
C    1IKEEP(1,3),IRN,LIRN,IW(1,3),IW(1,4),IW(1,5),IW(1,6),IW(1,7),    J/MA28A.30
C    2IW(1,8),IW(1,9),IW,UPRIV,IFLAG)                                 J/MA28A.30
C                                                                       MA28A.30
C TRANSFER COMMON BLOCK INFORMATION.                                    MA28A.30
 130  CALL MA30A(N,ICN,A,LICN,IKEEP,IKEEP(1,4),IDISP,IKEEP(1,2),
     AIKEEP(1,3),IRN,LIRN,IW(1,2),IW(1,3),IW(1,4),IW(1,5),IW(1,6),
     BIW(1,7),IW(1,8),IW,UPRIV,IFLAG)
      MINIRN=MIRN
      MINICN=MICN
      IRNCP=MIRNCP
      ICNCP=MICNCP
      IRANK=MIRANK
      IF (IFLAG.GE.0) GO TO 140
      IF (LP.NE.0) WRITE(LP,135)
 135  FORMAT(36X,26HERROR RETURN FROM MA30A/AD)
      GO TO 999
C                                                                       MA28A.31
C REORDER OFF-DIAGONAL BLOCKS ACCORDING TO PIVOT PERMUTATION.           MA28A.31
 140  I1=IDISP(1)-1
C     IF (I1.NE.0) CALL MC22AD(N,ICN,A,I1,IKEEP(1,5),IKEEP(1,2),     JD/MA28A.31
C    1IKEEP(1,3),IW,IRN)                                             JD/MA28A.32
C                                                                       MA28A.32
C OPTIONALLY CALCULATE ELEMENT GROWTH ESTIMATE.                         MA28A.32
      IF (I1.NE.0) CALL MC22A(N,ICN,A,I1,IKEEP(1,5),IKEEP(1,2),
     AIKEEP(1,3),IW,IRN)
      I1=IDISP(1)
      IEND=LICN-I1+1
C     IF (GROW) CALL MC24AD(N,ICN,A(I1),IEND,IKEEP,IKEEP(1,4),W)     JD/MA28A.32
C INCREMENT GROWTH ESTIMATE BY ORIGINAL MAXIMUM ELEMENT.                MA28A.32
      IF (GROW) CALL MC24A(N,ICN,A(I1),IEND,IKEEP,IKEEP(1,4),W)
      IF (GROW) W(1)=W(1)+THEMAX
      IF (GROW.AND.N.GT.1) W(2)=THEMAX
C SET FLAG IF THE ONLY ERROR IS DUE TO DUPLICATE ELEMENTS.              MA28A.33
      IF (IFLAG.GE.0.AND.IDUP.EQ.1) IFLAG=-14
      GO TO 1000
 999  IF (LP.NE.0) WRITE(LP,998)
 998  FORMAT(36H+ERROR RETURN FROM MA28A/AD BECAUSE )
 1000 RETURN
      END
      BLOCK DATA                                                        MA28A.33
C     DOUBLE PRECISION EPS,RMIN,RESID                                JD/
      REAL EPS,RMIN,RESID
      LOGICAL LBLOCK,GROW,ABORT1,ABORT2
      LOGICAL ABORT,ABORT3,ABORT1A,ABORT2A
C     COMMON /MA28ED/ LP,MP,LBLOCK,GROW                              JD/MA28A.34
      COMMON /MA28E/ LP,MP,LBLOCK,GROW
C     COMMON /MA28FD/ EPS,RMIN,RESID,IRNCP,ICNCP,MINIRN,MINICN,      JD/MA28A.34
C    1IRANK,ABORT1,ABORT2                                            JD/MA28A.34
      COMMON /MA28F/ EPS,RMIN,RESID,IRNCP,ICNCP,MINIRN,MINICN,
     AIRANK,ABORT1,ABORT2
      COMMON/MC23B/LP1,NUMNZ,NUM,LARGE,ABORT
      COMMON/MA30E/LP2,ABORT1A,ABORT2A,ABORT3
      COMMON/MA30G/EPS1,RMIN1
C     DATA EPS/1.0D-4/                                               JD/MA28A.34
      DATA EPS/1.0E-4/
      DATA LP/15/,MP/15/
      DATA LBLOCK/.TRUE./,GROW/.TRUE./
      DATA ABORT1/.TRUE./,ABORT2/.TRUE./
      DATA LP1/15/,LP2/15/
      DATA ABORT/.FALSE./,ABORT1A/.TRUE./,ABORT2A/.TRUE./
      DATA EPS1/1.E-4/,ABORT3/.FALSE./
      END
      SUBROUTINE MA28B(N,NZ,A,LICN,IVECT,JVECT,ICN,IKEEP,               MA28A.37
C     SUBROUTINE MA28BD(N,NZ,A,LICN,IVECT,JVECT,ICN,IKEEP,           JD/MA28A.35
C    1IW,W,IFLAG)                                                    JD/MA28A.35
C THE PARAMETERS ARE AS FOLLOWS ...                                     MA28A.35
C N      INTEGER  ORDER OF MATRIX  NOT ALTERED BY SUBROUTINE.           MA28A.35
C NZ     INTEGER  NUMBER OF NON-ZEROS IN INPUT MATRIX  NOT ALTERED      MA28A.35
C     BY SUBROUTINE.                                                    MA28A.36
C A      REAL/DOUBLE PRECISION ARRAY  LENGTH LICN.  HOLDS NON-ZEROS OF  MA28A.36
C     MATRIX ON ENTRY AND NON-ZEROS OF FACTORS ON EXIT.  REORDERED BY   MA28A.36
C     MA28D/DD AND ALTERED BY SUBROUTINE MA30B/BD.                      MA28A.36
C LICN   INTEGER  LENGTH OF ARRAYS A AND ICN.  NOT ALTERED BY           MA28A.36
C     SUBROUTINE.                                                       MA28A.36
C IVECT,JVECT  INTEGER*2 ARRAYS  LENGTH NZ.  HOLD ROW AND COLUMN        MA28A.36
C     INDICES OF NON-ZEROS RESPECTIVELY.  NOT ALTERED BY SUBROUTINE.    MA28A.36
C ICN    INTEGER*2 ARRAY  LENGTH LICN.  SAME ARRAY AS OUTPUT FROM       MA28A.36
C     MA28A/AD.  UNCHANGED BY MA28B/BD.                                 MA28A.36
C IKEEP  INTEGER*2 ARRAY  LENGTH 5*N.  SAME ARRAY AS OUTPUT FROM        MA28A.37
C     MA28A/AD.  UNCHANGED BY MA28B/BD.                                 MA28A.37
C IW     INTEGER ARRAY  LENGTH 4*N (5*N IN STANDARD VERSION).           MA28A.37
C     USED AS WORKSPACE BY MA28D/DD AND MA30B/BD.                       MA28A.37
C W      REAL/DOUBLE PRECISION ARRAY  LENGTH N.  USED AS WORKSPACE      MA28A.37
C     BY MA28D/DD,MA30B/BD AND (OPTIONALLY) MC24A/AD.                   MA28A.37
C IFLAG  INTEGER  USED AS ERROR FLAG WITH POSITIVE OR ZERO VALUE        MA28A.37
C     INDICATING SUCCESS.                                               MA28A.37
     1IW,W,IFLAG)
C     DOUBLE PRECISION A(LICN),W(N),EPS,MEPS,RMIN,MRMIN              JD/MA28A.38
C    1                ,RESID,WMAX,ACE                                JD/MA28A.38
      REAL A(LICN),W(N),MEPS,MRMIN
      INTEGER IDISP(2),IW(N,5)
      INTEGER IKEEP(N,5),IVECT(NZ),JVECT(NZ),ICN(LICN)
      LOGICAL GROW,LBLOCK,ABORTA,ABORTB,ABORT1,ABORT2,ABORT3
C UNLESS OTHERWISE STATED COMMON BLOCK VARIABLES ARE AS IN MA28A/AD.    MA28A.38
C     THOSE VARIABLES REFERENCED BY MA28B/BD ARE MENTIONED BELOW.       MA28A.38
C LP,MP  INTEGERS  USED AS IN MA28A/AD AS UNIT NUMBER FOR ERROR AND     MA28A.39
C     WARNING MESSAGES, RESPECTIVELY.                                   MA28A.39
C NLP    INTEGER VARIABLE USED TO GIVE VALUE OF LP TO MA30E/ED.         MA28A.39
C EPS    REAL/DOUBLE PRECISION  MA30B/BD WILL OUTPUT A POSITIVE VALUE   MA28A.39
C     FOR IFLAG IF ANY MODULUS OF THE RATIO OF PIVOT ELEMENT TO THE     MA28A.39
C     LARGEST ELEMENT IN ITS ROW (U PART ONLY) IS LESS THAN EPS (UNLESS MA28A.39
C     EPS IS GREATER THAN 1.0 WHEN NO ACTION TAKES PLACE).              MA28A.39
C RMIN   REAL/DOUBLE PRECISION  VARIABLE EQUAL TO THE VALUE OF THIS MINIMA28A.39
C     RATIO IN CASES WHERE EPS IS LESS THAN OR EQUAL TO 1.0             MA28A.39
C MEPS,MRMIN  REAL/DOUBLE PRECISION VARIABLES USED BY THE SUBROUTINE    MA28A.39
C     TO COMMUNICATE BETWEEN COMMON BLOCKS MA28F/FD AND MA30G/GD.       MA28A.40
C IDISP  INTEGER ARRAY  LENGTH 2  THE SAME AS THAT USED BY MA28A/AD.    MA28A.40
C     IT IS UNCHANGED BY MA28B/BD.                                      MA28A.40
C     COMMON /MA28ED/ MP,LP,LBLOCK,GROW                              JD/MA28A.40
      COMMON /MA28E/ MP,LP,LBLOCK,GROW
C     COMMON /MA28FD/ EPS,RMIN,RESID,IRNCP,ICNCP,MINIRN,MINICN,      JD/MA28A.40
C    1IRANK,ABORT1,ABORT2                                            JD/MA28A.40
      COMMON /MA28F/ EPS,RMIN,RESID,IRNCP,ICNCP,MINIRN,MINICN,
     AIRANK,ABORT1,ABORT2
C     COMMON /MA28GD/ IDISP                                          JD/MA28A.40
      COMMON /MA28G/ IDISP
C     COMMON /MA30ED/ NLP,ABORTA,ABORTB,ABORT3                       JD/MA28A.41
      COMMON /MA30E/ NLP,ABORTA,ABORTB,ABORT3
C     COMMON /MA30GD/ MEPS,MRMIN                                     JD/MA28A.41
      COMMON /MA30G/ MEPS,MRMIN
      IFLAG=0
      MEPS=EPS
      NLP=LP
C SIMPLE DATA CHECK ON VARIABLES.                                       MA28A.41
C     IF (N.GT.0) GO TO 2  SD/                                          MA28A.41
      IF (N.GT.0.AND.N.LE.32767) GO TO 2
      IFLAG=-11
      IF (LP.NE.0) WRITE(LP,1) N
 1    FORMAT(36X,17HN OUT OF RANGE = ,I10)
      GO TO 999
 2    IF (NZ.GT.0) GO TO 4
      IFLAG=-10
      IF (LP.NE.0) WRITE(LP,3) NZ
 3    FORMAT(36X,18HNZ NON POSITIVE = ,I10)
      GO TO 999
 4    IF (LICN.GE.NZ) GO TO 6
      IFLAG=-9
      IF (LP.NE.0) WRITE(LP,5) LICN
 5    FORMAT(36X,17HLICN TOO SMALL = ,I10)
      GO TO 999
C                                                                       MA28A.43
C6    CALL MA28DD(N,A,LICN,IVECT,JVECT,NZ,ICN,IKEEP,IKEEP(1,4),      JD/MA28A.43
C    1IKEEP(1,5),IKEEP(1,2),IKEEP(1,3),IW(1,3),IW,W(1),IFLAG)        JD/MA28A.43
C WMAX IS LARGEST ELEMENT IN MATRIX.                                    MA28A.43
 6    CALL MA28D(N,A,LICN,IVECT,JVECT,NZ,ICN,IKEEP,IKEEP(1,4),
     AIKEEP(1,5),IKEEP(1,2),IKEEP(1,3),IW(1,3),IW,W(1),IFLAG)
      WMAX=W(1)
C IDUP EQUALS ONE IF THERE WERE DUPLICATE ELEMENTS, ZERO OTHERWISE.     MA28A.44
      IDUP=0
      IF (IFLAG.EQ.(N+1)) IDUP=1
      IF (IFLAG.LT.0) GO TO 999
C                                                                       MA28A.44
C PERFORM ROW-GAUSS ELIMINATION ON THE STRUCTURE RECEIVED FROM MA28D/DD MA28A.44
C     CALL MA30BD(N,ICN,A,LICN,IKEEP,IKEEP(1,4),IDISP,IKEEP(1,2),    JD/MA28A.44
C    1IKEEP(1,3),W,IW,IFLAG)                                         JD/MA28A.44
C                                                                       MA28A.45
C TRANSFER COMMON BLOCK INFORMATION.                                    MA28A.45
      CALL MA30B(N,ICN,A,LICN,IKEEP,IKEEP(1,4),IDISP,IKEEP(1,2),
     AIKEEP(1,3),W,IW,IFLAG)
      RMIN=MRMIN
      IF (IFLAG.GE.0) GO TO 200
      IFLAG=-2
      IF (LP.NE.0) WRITE(LP,100)
 100  FORMAT(36X,26HERROR RETURN FROM MA30B/BD)
      GO TO 999
C                                                                       MA28A.46
C OPTIONALLY CALCULATE THE GROWTH PARAMETER.                            MA28A.46
 200  I1=IDISP(1)
      IEND=LICN-I1+1
C     IF (GROW) CALL MC24AD(N,ICN,A(I1),IEND,IKEEP,IKEEP(1,4),W)     JD/MA28A.46
C INCREMENT ESTIMATE BY LARGEST ELEMENT IN INPUT MATRIX.                MA28A.46
      IF (GROW) CALL MC24A(N,ICN,A(I1),IEND,IKEEP,IKEEP(1,4),W)
      IF (GROW) W(1)=W(1)+WMAX
C SET FLAG IF THE ONLY ERROR IS DUE TO DUPLICATE ELEMENTS.              MA28A.46
      IF (IDUP.EQ.1.AND.IFLAG.GE.0) IFLAG=-14
      GO TO 1000
 999  IF (LP.NE.0) WRITE(LP,998)
 998  FORMAT(36H+ERROR RETURN FROM MA28B/BD BECAUSE )
 1000 RETURN
      END
      SUBROUTINE MA28D(N,A,LICN,IVECT,JVECT,NZ,ICN,LENR,LENRL,          MA28A.48
C THIS SUBROUTINE NEED NEVER BE CALLED BY THE USER DIRECTLY.            MA28A.47
C     IT SORTS THE USER[S MATRIX INTO THE STRUCTURE OF THE DECOMPOSED   MA28A.47
C     FORM AND CHECKS FOR THE PRESENCE OF DUPLICATE ENTRIES OR          MA28A.47
C     NON-ZEROS LYING OUTSIDE THE SPARSITY PATTERN OF THE DECOMPOSITION MA28A.47
C     IT ALSO CALCULATES THE LARGEST ELEMENT IN THE INPUT MATRIX.       MA28A.47
C     SUBROUTINE MA28DD(N,A,LICN,IVECT,JVECT,NZ,ICN,LENR,LENRL,      JD/MA28A.48
C    1LENOFF,IP,IQ,IW1,IW,W1,IFLAG)                                  JD/MA28A.48
     1LENOFF,IP,IQ,IW1,IW,W1,IFLAG)
C     DOUBLE PRECISION A(LICN),ZERO,W1                               JD/MA28A.48
      REAL A(LICN)
      INTEGER IW(N,2),IDISP(2)
C     INTEGER   ICN(LICN),IVECT(NZ),JVECT(NZ),IP(N),IQ(N),     SD/      MA28A.48
C    1LENR(N),IW1(N,3),LENRL(N),LENOFF(N)  SD/                          MA28A.48
      INTEGER ICN(LICN),IVECT(NZ),JVECT(NZ),IP(N),IQ(N),
     ALENR(N),IW1(N,3),LENRL(N),LENOFF(N)
      LOGICAL LBLOCK,GROW
C     COMMON /MA28ED/ LP,MP,LBLOCK,GROW                              JD/MA28A.49
      COMMON /MA28E/ LP,MP,LBLOCK,GROW
C     COMMON /MA28GD/ IDISP                                          JD/MA28A.49
      COMMON /MA28G/ IDISP
C     DATA ZERO/0.0D0/                                               JD/MA28A.49
C IW1(I,3)  IS SET TO THE BLOCK IN WHICH ROW I LIES AND THE             MA28A.49
C     INVERSE PERMUTATIONS TO IP AND IQ ARE SET IN IW1(.,1) AND         MA28A.49
C     IW1(.,2) RESP.                                                    MA28A.49
C POINTERS TO BEGINNING OF THE PART OF ROW I IN DIAGONAL AND            MA28A.50
C   OFF-DIAGONAL BLOCKS ARE SET IN IW(I,2) AND IW(I,1) RESP.            MA28A.50
      DATA ZERO/0.0E0/
      IBLOCK=1
      IW(1,1)=1
      IW(1,2)=IDISP(1)
      DO 10 I=1,N
      IW1(I,3)=IBLOCK
      IF (IP(I).LT.0) IBLOCK=IBLOCK+1
      II=IABS(IP(I)+0)
      IW1(II,1)=I
      JJ=IQ(I)
      JJ=IABS(JJ)
      IW1(JJ,2)=I
      IF (I.EQ.1) GO TO 10
      IW(I,1)=IW(I-1,1)+LENOFF(I-1)
      IW(I,2)=IW(I-1,2)+LENR(I-1)
 10   CONTINUE
C PLACE EACH NON-ZERO IN TURN INTO ITS CORRECT LOCATION                 MA28A.51
C    IN THE A/ICN ARRAY.                                                MA28A.51
      DO 300 I=1,NZ
      IF (ICN(I).LT.0) GO TO 300
      IOLD=IVECT(I)
      JOLD=JVECT(I)
      AA=A(I)
C THIS IS A DUMMY LOOP FOR FOLLOWING A CHAIN OF INTERCHANGES.           MA28A.52
C   IT WILL BE EXECUTED NZ TIMES IN TOTAL.                              MA28A.52
      DO 200 IDUMMY=1,NZ
C PERFORM SOME VALIDITY CHECKS ON IOLD AND JOLD.                        MA28A.52
      IF (IOLD.LE.N .AND. IOLD.GT.0
     A      .AND. JOLD.LE.N .AND. JOLD.GT.0) GO TO 60
      IF (LP.NE.0) WRITE(LP,40) I,A(I),IOLD,JOLD
 40   FORMAT(9H ELEMENT ,I6,12H WITH VALUE ,1PD22.14,13H HAS INDICES ,I8
     A,2H ,,I8/36X,20HINDICES OUT OF RANGE)
      IFLAG=-12
      GO TO 1000
 60   INEW=IW1(IOLD,1)
      JNEW=IW1(JOLD,2)
C ARE WE IN A VALID BLOCK AND IS IT DIAGONAL OR OFF-DIAGONAL'           MA28A.53
      IF (IW1(INEW,3)-IW1(JNEW,3)) 70,100,90
 70   IFLAG=-13
      IF (LP.NE.0) WRITE(LP,80) IOLD,JOLD
 80   FORMAT(36X,8HNON-ZERO,I7,2H ,,I6,27H IN ZERO OFF-DIAGONAL BLOCK)
      GO TO 1000
 90   J1=IW(INEW,1)
      J2=J1+LENOFF(INEW)-1
      GO TO 160
C ELEMENT IS IN DIAGONAL BLOCK.                                         MA28A.54
 100  J1=IW(INEW,2)
      IF (INEW.GT.JNEW) GO TO 110
      J2=J1+LENR(INEW)-1
      J1=J1+LENRL(INEW)
      GO TO 160
 110  J2=J1+LENRL(INEW)
C BINARY SEARCH OF ORDERED LIST  .. ELEMENT IN L PART OF ROW.           MA28A.55
      DO 140 JDUMMY=1,N
      MIDPT=(J1+J2)/2
      JCOMP=IABS(ICN(MIDPT)+0)
      IF (JNEW-JCOMP) 120,180,130
 120  J2=MIDPT
      GO TO 140
 130  J1=MIDPT
 140  CONTINUE
      IFLAG=-13
      IF (LP.NE.0) WRITE(LP,150) IOLD,JOLD
 150  FORMAT(36X,8H ELEMENT,I6,2H ,,I6,23H WAS NOT IN L/U PATTERN)
      GO TO 1000
C LINEAR SEARCH ... ELEMENT IN L PART OF ROW OR OFF-DIAGONAL BLOCKS.    MA28A.56
 160  DO 170 MIDPT=J1,J2
      IF (IABS(ICN(MIDPT)+0).EQ.JNEW) GO TO 180
 170  CONTINUE
      IFLAG=-13
      IF (LP.NE.0) WRITE(LP,150) IOLD,JOLD
      GO TO 1000
C EQUIVALENT ELEMENT OF ICN IS IN POSITION MIDPT.                       MA28A.57
 180  IF (ICN(MIDPT).LT.0) GO TO 250
      IF (MIDPT.GT.NZ.OR.MIDPT.LE.I) GO TO 220
      W1=A(MIDPT)
      A(MIDPT)=AA
      AA=W1
      IOLD=IVECT(MIDPT)
      JOLD=JVECT(MIDPT)
      ICN(MIDPT)=-ICN(MIDPT)
 200  CONTINUE
 220  A(MIDPT)=AA
      ICN(MIDPT)=-ICN(MIDPT)
      GO TO 300
 250  A(MIDPT)=A(MIDPT)+AA
C SET FLAG FOR DUPLICATE ELEMENTS.                                      MA28A.58
      IFLAG=N+1
 300  CONTINUE
C RESET ICN ARRAY  AND ZERO ELEMENTS IN L/U BUT NOT IN A.               MA28A.59
C ALSO CALCULATE MAXIMUM ELEMENT OF A.                                  MA28A.59
      IDISP2=IDISP(2)
      W1=ZERO
      DO 400 I=1,IDISP2
      IF (ICN(I).LT.0) GO TO 350
      A(I)=ZERO
      GO TO 400
 350  ICN(I)=-ICN(I)
C     W1=DMAX1(W1,DABS(A(I)))                                        JD/MA28A.60
      W1=AMAX1(W1,ABS(A(I)))
 400  CONTINUE
 1000 RETURN
      END
      SUBROUTINE MA28C(N,A,LICN,ICN,IKEEP,RHS,W,MTYPE)                  MA28A.62
C     SUBROUTINE MA28CD(N,A,LICN,ICN,IKEEP,RHS,W,MTYPE)              JD/MA28A.60
C THE PARAMETERS ARE AS FOLLOWS ....                                    MA28A.60
C N     INTEGER  ORDER OF MATRIX  NOT ALTERED BY SUBROUTINE.            MA28A.60
C A      REAL/DOUBLE PRECISION ARRAY  LENGTH LICN.  THE SAME ARRAY AS   MA28A.60
C     WAS USED IN THE MOST RECENT CALL TO MA28A/AD OR MA28B/BD.         MA28A.61
C LICN  INTEGER  LENGTH OF ARRAYS A AND ICN.  NOT ALTERED BY            MA28A.61
C     SUBROUTINE.                                                       MA28A.61
C ICN    INTEGER*2 ARRAY  LENGTH LICN.  SAME ARRAY AS OUTPUT FROM       MA28A.61
C     MA28A/AD.  UNCHANGED BY MA28C/CD.                                 MA28A.61
C IKEEP  INTEGER*2 ARRAY  LENGTH 5*N.  SAME ARRAY AS OUTPUT FROM        MA28A.61
C     MA28A/AD.  UNCHANGED BY MA28C/CD.                                 MA28A.61
C RHS    REAL/DOUBLE PRECISION ARRAY  LENGTH N.  ON ENTRY, IT HOLDS THE MA28A.61
C     RIGHT HAND SIDE.  ON EXIT, THE SOLUTION VECTOR.                   MA28A.61
C W      REAL/DOUBLE PRECISION ARRAY  LENGTH N. USED AS WORKSPACE BY    MA28A.61
C     MA30C/CD.                                                         MA28A.62
C MTYPE  INTEGER  USED TO TELL MA30C/CD TO SOLVE THE DIRECT EQUATION    MA28A.62
C     (MTYPE=1) OR ITS TRANSPOSE (MTYPE.NE.1).                          MA28A.62
C     DOUBLE PRECISION A(LICN),RHS(N),W(N),MRESID,EPS,RMIN,RESID     JD/MA28A.62
      REAL A(LICN),RHS(N),W(N),MRESID
      INTEGER IDISP(2)
C     INTEGER   ICN(LICN),IKEEP(N,5) SD/                                MA28A.62
      INTEGER ICN(LICN),IKEEP(N,5)
      LOGICAL ABORT1,ABORT2
C UNLESS OTHERWISE STATED COMMON BLOCK VARIABLES ARE AS IN MA28A/AD.    MA28A.63
C     THOSE VARIABLES REFERENCED BY MA28C/CD ARE MENTIONED BELOW.       MA28A.63
C RESID  REAL/DOUBLE PRECISION  VARIABLE RETURNS MAXIMUM RESIDUAL OF    MA28A.63
C     EQUATIONS WHERE PIVOT WAS ZERO.                                   MA28A.63
C MRESID  REAL/DOUBLE PRECISION VARIABLE USED BY MA28C/CD TO            MA28A.63
C     COMMUNICATE BETWEEN MA28F/FD AND MA30H/HD.                        MA28A.63
C IDISP  INTEGER ARRAY  LENGTH 2  THE SAME AS THAT USED BY MA28A/AD.    MA28A.63
C     IT IS UNCHANGED BY MA28B/BD.                                      MA28A.63
C     COMMON /MA28FD/ EPS,RMIN,RESID,IRNCP,ICNCP,MINIRN,MINICN,      JD/MA28A.63
C    1IRANK,ABORT1,ABORT2                                            JD/MA28A.63
      COMMON /MA28F/ EPS,RMIN,RESID,IRNCP,ICNCP,MINIRN,MINICN,
     AIRANK,ABORT1,ABORT2
C     COMMON /MA28GD/ IDISP                                          JD/MA28A.64
      COMMON /MA28G/ IDISP
C     COMMON /MA30HD/ MRESID                                         JD/MA28A.64
C                                                                       MA28A.64
C THIS SUBROUTINE PERFORMS THE SOLUTION OF THE SET OF EQUATIONS.        MA28A.64
      COMMON /MA30H/ MRESID
C     CALL MA30CD(N,ICN,A,LICN,IKEEP,IKEEP(1,4),IKEEP(1,5),IDISP,    JD/MA28A.64
C    1IKEEP(1,2),IKEEP(1,3),RHS,W,MTYPE)                             JD/MA28A.64
C                                                                       MA28A.65
C TRANSFER COMMON BLOCK INFORMATION.                                    MA28A.65
      CALL MA30C(N,ICN,A,LICN,IKEEP,IKEEP(1,4),IKEEP(1,5),IDISP,
     AIKEEP(1,2),IKEEP(1,3),RHS,W,MTYPE)
      RESID=MRESID
      RETURN
      END
